local sassabilities1 = CV_RegisterVar({
name = "sassabilities1",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sassabilities2 = CV_RegisterVar({
name = "sassabilities2",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sassban = CV_RegisterVar({
name = "sassban",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sasspickup = CV_RegisterVar({
name = "sasspickup",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sasscheckpoint = CV_RegisterVar({
name = "sasscheckpoint",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sassdeath = CV_RegisterVar({
name = "sassdeath",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sassshop = CV_RegisterVar({
name = "sassshop",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sassswitch = CV_RegisterVar({
name = "sassswitch",
defaultvalue = 1,
flags =	CV_NETVAR,
possiblevalue = CV_OnOff
})
local sassvisuals = CV_RegisterVar({
name = "sassvisuals",
defaultvalue = 1,
possiblevalue = CV_OnOff
})

//Menu
local SASSMenu = 0
local SASSMenuTimeout = 0
local SASSChoice = 0
local SASSPage = 0
local SASSBalance = 0
local SASSCanShop = 0
local SASSCanSwitch = 0
local SASSGotAll = 0
//Input
local SASSUP = 0
local SASSDOWN = 0
local SASSLEFT = 0
local SASSRIGHT = 0

local function SASSMenuEntrance(v, p, camera)
	if not(p.mo and p.mo.valid)
		return
	end
//Menu Prompt
	if (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WAIT) and SASSMenu == 0
		v.drawString( 160, 4, "\x82 CUSTOM1+CUSTOM2 for SASS menu",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
	elseif (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WAIT) and SASSMenu == 1
		if SASSPage == 0
			v.drawString( 160, 4, "\x82 SPIN to EXIT",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
		end
		if SASSPage == 0
			v.drawString( 160, 9, "\x82 JUMP to CHOOSE",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
		elseif SASSPage == 1
			v.drawString( 160, 9, "\x82 JUMP to SWITCH",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
		elseif SASSPage == 2
			v.drawString( 160, 9, "\x82 JUMP to CHOOSE",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
		elseif SASSPage == 3
			v.drawString( 160, 9, "\x82 JUMP to CHOOSE",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
		end
		if SASSPage > 0
			v.drawString( 160, 4, "\x82 SPIN to GO BACK",  V_20TRANS|V_SNAPTOTOP|V_ALLOWLOWERCASE, "small-center")
		end
	end
//Menu Screen - Base
	if SASSMenu
		if SASSPage == 0 //Main screen
			if SASSChoice == 0
				v.drawString( 80, 60, "\x82  SETTINGS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
			else
				v.drawString( 80, 60, "SETTINGS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
			end
			if SASSChoice == 1
				if sassshop.value
					v.drawString( 80, 110, "\x82  SHOP",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				else
					v.drawString( 80, 110, "\x85".."  DISABLED",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				end
			else
				if sassshop.value
					v.drawString( 80, 110, "SHOP",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				else
					v.drawString( 80, 110, "\x85".."DISABLED",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				end
			end
			if SASSChoice == 2
				if sassswitch.value
					v.drawString( 80, 160, "\x82  SASS SWITCH",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				else
					v.drawString( 80, 160, "\x85".."  DISABLED",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				end
			else
				if sassswitch.value
					v.drawString( 80, 160, "SASS SWITCH",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				else
					v.drawString( 80, 160, "\x85".."DISABLED",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "left")
				end
			end
		end
		if SASSPage == 1 //Settings
			v.drawString( 164, 60, "SETTINGS",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			if SASSChoice == 0
				v.drawString( 80, 80, "\x85".."ADMIN ".."\x82  PRIMARY ABILITIES",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 80, "\x85".."ADMIN ".."\x80".."PRIMARY ABILITIES",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 1
				v.drawString( 80, 89, "\x85".."ADMIN ".."\x82  SECONDARY ABIITIES",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 89, "\x85".."ADMIN ".."\x80".."SECONDARY ABIITIES",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 2
				v.drawString( 80, 98, "\x85".."ADMIN ".."\x82  BAN SKINS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 98, "\x85".."ADMIN ".."\x80".."BAN SKINS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 3
				v.drawString( 80, 107, "\x85".."ADMIN ".."\x82  PLATE COLLECTION",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 107, "\x85".."ADMIN ".."\x80".."PLATE COLLECTION",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 4
				v.drawString( 80, 116, "\x85".."ADMIN ".."\x82  PLATE CHECKPOINTS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 116, "\x85".."ADMIN ".."\x80".."PLATE CHECKPOINTS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 5
				v.drawString( 80, 125, "\x85".."ADMIN ".."\x82  DEATH LOSS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 125, "\x85".."ADMIN ".."\x80".."DEATH LOSS",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 6
				v.drawString( 80, 134, "\x82  ABILITY VFX",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 134, "ABILITY VFX",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 7
				v.drawString( 80, 143, "\x85".."ADMIN ".."\x82  SASS SHOP",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 143, "\x85".."ADMIN ".."\x80".."SASS SHOP",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if SASSChoice == 8
				v.drawString( 80, 152, "\x85".."ADMIN ".."\x82  SASS SWITCH",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 80, 152, "\x85".."ADMIN ".."\x80".."SASS SWITCH",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			
			if sassabilities1.value
				v.drawString( 210, 80, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 80, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sassabilities2.value
				v.drawString( 210, 89, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 89, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sassban.value
				v.drawString( 210, 98, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 98, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sasspickup.value
				v.drawString( 210, 107, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 107, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sasscheckpoint.value
				v.drawString( 210, 116, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 116, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sassdeath.value
				v.drawString( 210, 125, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 125, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sassvisuals.value
				v.drawString( 210, 134, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 134, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sassshop.value
				v.drawString( 210, 143, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 143, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
			if sassswitch.value
				v.drawString( 210, 152, "\x83ON",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			else
				v.drawString( 210, 152, "\x85OFF",  V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin")
			end
		end
		if SASSPage == 2 //Shop
			v.drawString( 164, 60, "SHOP",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			if SASSChoice == 0
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."FLOWING LAVA",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(85*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS1"), V_SNAPTOTOP)
			else
				v.drawScaled(87*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS1"), V_SNAPTOTOP)
			end
			if SASSChoice == 1
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."ACTIVE NITRO",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(107*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS2"), V_SNAPTOTOP)
			else
				v.drawScaled(109*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS2"), V_SNAPTOTOP)
			end
			if SASSChoice == 2
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."BEE PATTERN",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(129*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS3"), V_SNAPTOTOP)
			else
				v.drawScaled(131*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS3"), V_SNAPTOTOP)
			end
			if SASSChoice == 3
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."DEEP SEA",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(151*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS4"), V_SNAPTOTOP)
			else
				v.drawScaled(153*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS4"), V_SNAPTOTOP)
			end
			if SASSChoice == 4
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."TOXIC RADIATION",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(173*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS5"), V_SNAPTOTOP)
			else
				v.drawScaled(175*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS5"), V_SNAPTOTOP)
			end
			if SASSChoice == 5
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."PEPPERMINT CANDY",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(195*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS6"), V_SNAPTOTOP)
			else
				v.drawScaled(197*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS6"), V_SNAPTOTOP)
			end
			if SASSChoice == 6
				SASSBalance = 50
				v.drawString( 160, 104, "\x82".."GOAT HORN",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawScaled(217*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS7"), V_SNAPTOTOP)
			else
				v.drawScaled(219*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS7"), V_SNAPTOTOP)
			end
			v.drawString( 164, 134, "PRESS JUMP TO BUY FOR",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			v.drawString( 164, 142, "\x82"..SASSBalance.."\x80".." RINGS",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			if p.rings < SASSBalance
				v.drawString( 164, 150, "\x85".."CAN'T AFFORD! "..SASSBalance-p.rings.." RINGS LEFT",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				SASSCanShop = 0
			else
				v.drawString( 164, 150, "\x83".."CAN AFFORD!",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				SASSCanShop = 1
			end
		end
		if SASSPage == 3 //Switch
			v.drawString( 164, 60, "SASS SWITCH",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			if SASSChoice == 0
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."FLOWING LAVA",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.FLOwned
					v.drawScaled(85*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS1"), V_SNAPTOTOP)
				else
					v.drawScaled(85*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS1"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.FLOwned
					v.drawScaled(87*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS1"), V_SNAPTOTOP)
				else
					v.drawScaled(87*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS1"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if SASSChoice == 1
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."ACTIVE NITRO",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.ANOwned
					v.drawScaled(107*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS2"), V_SNAPTOTOP)
				else
					v.drawScaled(107*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS2"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.ANOwned
					v.drawScaled(109*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS2"), V_SNAPTOTOP)
				else
					v.drawScaled(109*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS2"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if SASSChoice == 2
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."BEE PATTERN",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.BPOwned
					v.drawScaled(129*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS3"), V_SNAPTOTOP)
				else
					v.drawScaled(129*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS3"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.BPOwned
					v.drawScaled(131*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS3"), V_SNAPTOTOP)
				else
					v.drawScaled(131*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS3"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if SASSChoice == 3
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."DEEP SEA",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.DSOwned
					v.drawScaled(151*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS4"), V_SNAPTOTOP)
				else
					v.drawScaled(151*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS4"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.DSOwned
					v.drawScaled(153*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS4"), V_SNAPTOTOP)
				else
					v.drawScaled(153*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS4"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if SASSChoice == 4
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."TOXIC RADIATION",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.TROwned
					v.drawScaled(173*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS5"), V_SNAPTOTOP)
				else
					v.drawScaled(173*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS5"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.TROwned
					v.drawScaled(175*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS5"), V_SNAPTOTOP)
				else
					v.drawScaled(175*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS5"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if SASSChoice == 5
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."PEPPERMINT CANDY",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.PCOwned
					v.drawScaled(195*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS6"), V_SNAPTOTOP)
				else
					v.drawScaled(195*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS6"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.PCOwned
					v.drawScaled(197*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS6"), V_SNAPTOTOP)
				else
					v.drawScaled(197*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS6"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if SASSChoice == 6
				SASSBalance = 30
				v.drawString( 160, 104, "\x82".."GOAT HORN",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				if p.GHOwned
					v.drawScaled(217*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS7"), V_SNAPTOTOP)
				else
					v.drawScaled(217*FRACUNIT, 80*FRACUNIT, FRACUNIT*5/7, v.cachePatch("SASS7"), V_50TRANS|V_SNAPTOTOP)
				end
			else
				if p.GHOwned
					v.drawScaled(219*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS7"), V_SNAPTOTOP)
				else
					v.drawScaled(219*FRACUNIT, 82*FRACUNIT, FRACUNIT*4/7, v.cachePatch("SASS7"), V_50TRANS|V_SNAPTOTOP)
				end
			end
			if not SASSGotAll
				v.drawString( 164, 134, "PRESS JUMP TO SWITCH FOR",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawString( 164, 142, "\x82"..SASSBalance.."\x80".." RINGS",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			else
				v.drawString( 164, 134, "CONGRATULATIONS! YOU GOT THEM ALL!",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				v.drawString( 164, 142, "PRESS JUMP TO SWITCH FOR ".."\x82".."FREE",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				SASSCanSwitch = 1
				SASSBalance = 0
			end
			if p.rings < SASSBalance
			and ((p.FLOwned and SASSChoice == 0)
			or (p.ANOwned and SASSChoice == 1)
			or (p.BPOwned and SASSChoice == 2)
			or (p.DSOwned and SASSChoice == 3)
			or (p.TROwned and SASSChoice == 4)
			or (p.PCOwned and SASSChoice == 5)
			or (p.GHOwned and SASSChoice == 6))
				SASSCanSwitch = 0
				v.drawString( 164, 150, "\x85".."CAN'T SWITCH! "..SASSBalance-p.rings.." RINGS LEFT",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			elseif (not p.FLOwned and SASSChoice == 0)
			or (not p.ANOwned and SASSChoice == 1)
			or (not p.BPOwned and SASSChoice == 2)
			or (not p.DSOwned and SASSChoice == 3)
			or (not p.TROwned and SASSChoice == 4)
			or (not p.PCOwned and SASSChoice == 5)
			or (not p.GHOwned and SASSChoice == 6)
				SASSCanSwitch = 0
				v.drawString( 164, 150, "\x85".."CAN'T SWITCH! SKINCOLOR NOT COLLECTED",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			else
				if not SASSGotAll
					SASSCanSwitch = 1
					v.drawString( 164, 150, "\x83".."CAN SWITCH!",  V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
				else
					SASSCanSwitch = 1
				end
			end
		end
	end
end
hud.add(SASSMenuEntrance, "game")


addHook("PreThinkFrame", do
	for p in players.iterate do
		if SASSMenu
			if p.cmd.forwardmove > 0
				SASSUP = 1
				SASSDOWN = 0
			elseif p.cmd.forwardmove < 0
				SASSDOWN = 1
				SASSUP = 0
			elseif p.cmd.forwardmove == 0
				SASSDOWN = 0
				SASSUP = 0
			end
			if p.cmd.sidemove > 0
				SASSRIGHT = 0
				SASSLEFT = 1
			elseif p.cmd.sidemove < 0
				SASSRIGHT = 1
				SASSLEFT = 0
			elseif p.cmd.sidemove == 0
				SASSRIGHT = 0
				SASSLEFT = 0
			end
		end
	end
end)
	
addHook("ThinkFrame", do
	for p in players.iterate do
		if not (p.mo and p.valid)
			return
		end
		
		if (p.FLOwned and p.ANOwned and p.BPOwned and p.DSOwned and p.TROwned and p.PCOwned and p.GHOwned)
			if not SASSGotAll
				S_StartSound(p.mo, sfx_cdfm73)
				SASSGotAll = 1
			end
		end
//Access the menu		
		if (p.cmd.buttons & BT_CUSTOM1) and (p.cmd.buttons & BT_CUSTOM2) and not SASSMenu
		and (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WAIT)
		and SASSMenuTimeout == 0
			SASSMenu = 1
			SASSMenuTimeout = 10
		end
			
		if SASSMenuTimeout > 0
			SASSMenuTimeout = $-1
		end
		
		if (p.cmd.buttons & BT_USE) and SASSMenu
		and (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WAIT)
		and SASSMenuTimeout == 0 and SASSPage == 0
			p.pflags = $|PF_USEDOWN & ~PF_INVIS & ~PF_GODMODE & ~PF_FORCESTRAFE & ~PF_STARTDASH & ~PF_SPINNING & ~PF_JUMPED & ~PF_STASIS & ~PF_JUMPSTASIS & ~PF_THOKKED
			SASSMenu = 0
			SASSMenuTimeout = 5
			SASSChoice = 0
			SASSPage = 0
		end
//Menu Screen - Base
		if SASSMenu
			p.pflags = $|PF_INVIS|PF_GODMODE|PF_FORCESTRAFE|PF_JUMPDOWN|PF_USEDOWN|PF_JUMPED|PF_THOKKED|PF_JUMPSTASIS & ~PF_SPINNING & ~PF_STARTDASH
			p.powers[pw_nocontrol] = 2
			if SASSPage == 0 and not SASSMenuTimeout //Main Screen
				if SASSUP
					SASSChoice = $-1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				elseif SASSDOWN
					SASSChoice = $+1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				end
				
				if SASSChoice < 0
					SASSChoice = 2
				elseif SASSChoice > 2
					SASSChoice = 0
				end
				
				if (p.cmd.buttons&BT_JUMP) and SASSChoice == 0
					SASSChoice = 0
					SASSPage = 1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_zoom)
				end
				if (p.cmd.buttons&BT_JUMP) and SASSChoice == 1
					if sassshop.value
						SASSChoice = 0
						SASSPage = 2
						SASSMenuTimeout = 5
						S_StartSound(p.mo, sfx_zoom)
					else
						S_StartSound(p.mo, sfx_adderr)
						SASSMenuTimeout = 5
					end
				end
				if (p.cmd.buttons&BT_JUMP) and SASSChoice == 2
					if sassswitch.value
						SASSChoice = 0
						SASSPage = 3
						SASSMenuTimeout = 5
						S_StartSound(p.mo, sfx_zoom)
					else
						S_StartSound(p.mo, sfx_adderr)
						SASSMenuTimeout = 5
					end
				end
			elseif SASSPage == 1 and not SASSMenuTimeout //Settings
				if SASSUP
					SASSChoice = $-1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				elseif SASSDOWN
					SASSChoice = $+1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				end
				
				if SASSChoice < 0
					SASSChoice = 8
				elseif SASSChoice > 8
					SASSChoice = 0
				end
				
				if (p.cmd.buttons&BT_JUMP)
					if SASSChoice == 0
						if sassabilities1.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassabilities1 off")
								local file = io.openlocal("client/SASS/SASS_Primary.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassabilities1 on")
								local file = io.openlocal("client/SASS/SASS_Primary.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 1
						if sassabilities2.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassabilities2 off")
								local file = io.openlocal("client/SASS/SASS_Secondary.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassabilities2 on")
								local file = io.openlocal("client/SASS/SASS_Secondary.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 2
						if sassban.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassban off")
								local file = io.openlocal("client/SASS/SASS_Ban.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassban on")
								local file = io.openlocal("client/SASS/SASS_Ban.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 3
						if sasspickup.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sasspickup off")
								local file = io.openlocal("client/SASS/SASS_Pickup.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sasspickup on")
								local file = io.openlocal("client/SASS/SASS_Pickup.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 4
						if sasscheckpoint.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sasscheckpoint off")
								local file = io.openlocal("client/SASS/SASS_Checkpoint.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sasscheckpoint on")
								local file = io.openlocal("client/SASS/SASS_Checkpoint.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 5
						if sassdeath.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassdeath off")
								local file = io.openlocal("client/SASS/SASS_Death.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassdeath on")
								local file = io.openlocal("client/SASS/SASS_Death.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 6
						if sassvisuals.value
							SASSMenuTimeout = 5
							COM_BufInsertText(p, "sassvisuals off")
							local file = io.openlocal("client/SASS/SASS_Visuals.dat", "w")
							file:write("0")
							file:close()
							S_StartSound(p.mo, sfx_s3kad)
						else
							SASSMenuTimeout = 5
							COM_BufInsertText(p, "sassvisuals on")
							local file = io.openlocal("client/SASS/SASS_Visuals.dat", "w")
							file:write("1")
							file:close()
							S_StartSound(p.mo, sfx_s3kad)
						end
					elseif SASSChoice == 7
						if sassshop.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassshop off")
								local file = io.openlocal("client/SASS/SASS_Shop.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassshop on")
								local file = io.openlocal("client/SASS/SASS_Shop.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					elseif SASSChoice == 8
						if sassswitch.value
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassswitch off")
								local file = io.openlocal("client/SASS/SASS_Switch.dat", "w")
								file:write("0")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						else
							if not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
								SASSMenuTimeout = 5
								COM_BufInsertText(p, "sassswitch on")
								local file = io.openlocal("client/SASS/SASS_Switch.dat", "w")
								file:write("1")
								file:close()
								S_StartSound(p.mo, sfx_s3kad)
							else
								CONS_Printf(p,"Sorry, but you don't have permission to change this setting.")
								SASSMenuTimeout = 5
								S_StartSound(p.mo, sfx_adderr)
							end
						end
					end
				end	
				
				if (p.cmd.buttons&BT_USE)
					SASSChoice = 0
					SASSPage = 0
					S_StartSound(p.mo, sfx_zoom)
					SASSMenuTimeout = 5
				end
			elseif SASSPage == 2 and not SASSMenuTimeout //Shop
				if SASSRIGHT
					SASSChoice = $-1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				elseif SASSLEFT
					SASSChoice = $+1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				end
				
				if SASSChoice < 0
					SASSChoice = 6
				elseif SASSChoice > 6
					SASSChoice = 0
				end
				
				if (p.cmd.buttons&BT_USE)
					SASSChoice = 1
					SASSPage = 0
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_zoom)
				end
				
				if (p.cmd.buttons&BT_JUMP)
					SASSMenuTimeout = 5
					if SASSCanShop
						S_StartSound(p.mo, sfx_chchng)
						p.rings = $-SASSBalance
						local spark = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z - (1 * p.mo.height)/2, MT_SUPERSPARK)
						spark.scale = 2 * p.mo.scale
						if SASSChoice == 0
							p.skincolor = SKINCOLOR_FLOWINGLAVA
							p.mo.color = SKINCOLOR_FLOWINGLAVA
							p.FLPickup = 1
							p.ANPickup = 0
							p.BPPickup = 0
							p.DSPickup = 0
							p.TRPickup = 0
							p.PCPickup = 0
							p.GHPickup = 0
						elseif SASSChoice == 1
							p.skincolor = SKINCOLOR_ACTIVENITRO
							p.mo.color = SKINCOLOR_ACTIVENITRO
							p.FLPickup = 0
							p.ANPickup = 1
							p.BPPickup = 0
							p.DSPickup = 0
							p.TRPickup = 0
							p.PCPickup = 0
							p.GHPickup = 0
						elseif SASSChoice == 2
							p.skincolor = SKINCOLOR_BEEPATTERN
							p.mo.color = SKINCOLOR_BEEPATTERN
							p.FLPickup = 0
							p.ANPickup = 0
							p.BPPickup = 1
							p.DSPickup = 0
							p.TRPickup = 0
							p.PCPickup = 0
							p.GHPickup = 0
						elseif SASSChoice == 3
							p.skincolor = SKINCOLOR_DEEPSEA
							p.mo.color = SKINCOLOR_DEEPSEA
							p.FLPickup = 0
							p.ANPickup = 0
							p.BPPickup = 0
							p.DSPickup = 1
							p.TRPickup = 0
							p.PCPickup = 0
							p.GHPickup = 0
						elseif SASSChoice == 4
							p.skincolor = SKINCOLOR_TOXICRADIATION
							p.mo.color = SKINCOLOR_TOXICRADIATION
							p.FLPickup = 0
							p.ANPickup = 0
							p.BPPickup = 0
							p.DSPickup = 0
							p.TRPickup = 1
							p.PCPickup = 0
							p.GHPickup = 0
						elseif SASSChoice == 5
							p.skincolor = SKINCOLOR_PEPPERMINTCANDY
							p.mo.color = SKINCOLOR_PEPPERMINTCANDY
							p.FLPickup = 0
							p.ANPickup = 0
							p.BPPickup = 0
							p.DSPickup = 0
							p.TRPickup = 0
							p.PCPickup = 1
							p.GHPickup = 0
						elseif SASSChoice == 6
							p.skincolor = SKINCOLOR_GOATHORN
							p.mo.color = SKINCOLOR_GOATHORN
							p.FLPickup = 0
							p.ANPickup = 0
							p.BPPickup = 0
							p.DSPickup = 0
							p.TRPickup = 0
							p.PCPickup = 0
							p.GHPickup = 1
						end
					elseif not SASSCanShop
						S_StartSound(p.mo, sfx_adderr)
					end
				end
			elseif SASSPage == 3 and not SASSMenuTimeout //Switch
				if SASSRIGHT
					SASSChoice = $-1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				elseif SASSLEFT
					SASSChoice = $+1
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_s3kb7)
				end
				
				if SASSChoice < 0
					SASSChoice = 6
				elseif SASSChoice > 6
					SASSChoice = 0
				end
				
				if (p.cmd.buttons&BT_USE)
					SASSChoice = 2
					SASSPage = 0
					SASSMenuTimeout = 5
					S_StartSound(p.mo, sfx_zoom)
				end
				if (p.cmd.buttons&BT_JUMP)
					SASSMenuTimeout = 5
					if (not SASSGotAll and p.rings>= SASSBalance
					and SASSCanSwitch) or (SASSGotAll and SASSCanSwitch)
						S_StartSound(p.mo, sfx_chchng)
						p.rings = $-SASSBalance
						local spark = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z - (1 * p.mo.height)/2, MT_SUPERSPARK)
						spark.scale = 2 * p.mo.scale
						if SASSChoice == 0
							p.skincolor = SKINCOLOR_FLOWINGLAVA
							p.mo.color = SKINCOLOR_FLOWINGLAVA
						elseif SASSChoice == 1
							p.skincolor = SKINCOLOR_ACTIVENITRO
							p.mo.color = SKINCOLOR_ACTIVENITRO
						elseif SASSChoice == 2
							p.skincolor = SKINCOLOR_BEEPATTERN
							p.mo.color = SKINCOLOR_BEEPATTERN
						elseif SASSChoice == 3
							p.skincolor = SKINCOLOR_DEEPSEA
							p.mo.color = SKINCOLOR_DEEPSEA
						elseif SASSChoice == 4
							p.skincolor = SKINCOLOR_TOXICRADIATION
							p.mo.color = SKINCOLOR_TOXICRADIATION
						elseif SASSChoice == 5
							p.skincolor = SKINCOLOR_PEPPERMINTCANDY
							p.mo.color = SKINCOLOR_PEPPERMINTCANDY
						elseif SASSChoice == 6
							p.skincolor = SKINCOLOR_GOATHORN
							p.mo.color = SKINCOLOR_GOATHORN
						end
					elseif not SASSCanSwitch
						S_StartSound(p.mo, sfx_adderr)
						SASSMenuTimeout = 5
					end
				end
			end	
		end
	end
end)

if io
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Primary.dat"
			if p.valid
			and not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassabilities1 "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Secondary.dat"
			if p.valid
			and not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassabilities2 "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Ban.dat"
			if p.valid
			and not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassban "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Pickup.dat"
			if p.valid
			and not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sasspickup "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Checkpoint.dat"
			if p.valid
			and not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sasscheckpoint "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Death.dat"
			if p.valid
			and not multiplayer or (multiplayer and (server and p == server) or IsPlayerAdmin(player))
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassdeath "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Visuals.dat"
			if p.valid
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassvisuals "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Shop.dat"
			if p.valid
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassshop "..val)
					file:close()
					return
				end
			end
		end
	end)
	addHook("MapLoad", do
		for p in players.iterate do
			local FILENAME = "client/SASS/SASS_Switch.dat"
			if p.valid
				local file = io.openlocal(FILENAME)
				if file
					local val = file:read("*n")
					COM_BufInsertText(p, "sassswitch "..val)
					file:close()
					return
				end
			end
		end
	end)
end



COM_AddCommand("sass_primary", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_primary on/off\x80 - Enable or disable primary skincolor abilities ingame.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("\x82SASS Primary Abilities\x80 have been disabled.")
		COM_BufInsertText(p, "sassabilities1 off")
		local file = io.openlocal("client/SASS/SASS_Primary.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("\x82SASS Primary Abilities\x80 have been enabled.")
		COM_BufInsertText(p, "sassabilities1 on")
		local file = io.openlocal("client/SASS/SASS_Primary.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_secondary", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_secondary on/off\x80 - Enable or disable secondary skincolor abilities ingame.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("\x82SASS Secondary Abilities\x80 have been disabled.")
		COM_BufInsertText(p, "sassabilities2 off")
		local file = io.openlocal("client/SASS/SASS_Secondary.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("\x82SASS Secondary Abilities\x80 have been enabled.")
		COM_BufInsertText(p, "sassabilities2 on")
		local file = io.openlocal("client/SASS/SASS_Secondary.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_ban", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_ban on/off\x80 - Enable or disable skincolor banning for when selected directly.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("\x82SASS Abilities\x80 are no longer banned when selected directly.")
		COM_BufInsertText(p, "sassban off")
		local file = io.openlocal("client/SASS/SASS_Ban.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("\x82SASS Abilities\x80 are now banned when selected directly.")
		COM_BufInsertText(p, "sassban on")
		local file = io.openlocal("client/SASS/SASS_Ban.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_pickup", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_pickup on/off\x80 - Enable or disable gaining SASS' through other means.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("You no longer collect SASS from some cases.")
		COM_BufInsertText(p, "sasspickup off")
		local file = io.openlocal("client/SASS/SASS_Pickup.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("You now are able to collect SASS from some cases.")
		COM_BufInsertText(p, "sasspickup on")
		local file = io.openlocal("client/SASS/SASS_Pickup.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_checkpoint", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_checkpoint on/off\x80 - Enable or disable gaining SASS' through checkpoints.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("You no longer collect SASS from checkpoints.")
		COM_BufInsertText(p, "sasscheckpoint off")
		local file = io.openlocal("client/SASS/SASS_Checkpoint.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("You now are able to collect SASS from checkpoints.")
		COM_BufInsertText(p, "sasscheckpoint on")
		local file = io.openlocal("client/SASS/SASS_Checkpoint.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_death", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_death on/off\x80 - Enable or disable reverting your skincolor back to the original one once you die with \x82SASS\x80 on after you pick up a plate.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("You will no longer revert your skincolor back to the original one once you die with \x82SASS\x80 on after you pick up a plate.")
		COM_BufInsertText(p, "sassdeath off")
		local file = io.openlocal("client/SASS/SASS_Death.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("You now revert your skincolor back to the original one once you die with \x82SASS\x80 on after you pick up a plate.")
		COM_BufInsertText(p, "sassdeath on")
		local file = io.openlocal("client/SASS/SASS_Death.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_visuals", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_visuals on/off\x80 - Enable or disable skincolor abilities ingame.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("\x82SASS Visuals\x80 have been disabled.")
		COM_BufInsertText(p, "sassvisuals off")
		local file = io.openlocal("client/SASS/SASS_Visuals.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("\x82SASS Visuals\x80 have been enabled.")
		COM_BufInsertText(p, "sassvisuals on")
		local file = io.openlocal("client/SASS/SASS_Visuals.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_LOCAL)
COM_AddCommand("sass_shop", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_shop on/off\x80 - Enable or disable the \x82SASS Shop\x80 accessible in its menu.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("\x82SASS Shop\x80 is now disabled.")
		COM_BufInsertText(p, "sassshop off")
		local file = io.openlocal("client/SASS/SASS_Shop.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("\x82SASS Shop\x80 is now enabled.")
		COM_BufInsertText(p, "sassshop on")
		local file = io.openlocal("client/SASS/SASS_Shop.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)
COM_AddCommand("sass_switch", function(p, arg)
	if arg == nil
		CONS_Printf(p, "\x82sass_switch on/off\x80 - Enable or disable \x82SASS Switching\x80 accessible in its menu.")
	end
	
	if arg == "off" or arg == "0" or arg == "false" or arg == "no" or arg == "n"
		print("\x82SASS Switching\x80 is now disabled.")
		COM_BufInsertText(p, "sassswitch off")
		local file = io.openlocal("client/SASS/SASS_Switch.dat", "w")
		file:write("0")
		file:close()
	elseif arg == "on" or arg == "1" or arg == "true" or arg == "yes" or arg == "y" or arg == "default"
		print("\x82SASS Switching\x80 is now enabled.")
		COM_BufInsertText(p, "sassswitch on")
		local file = io.openlocal("client/SASS/SASS_Switch.dat", "w")
		file:write("1")
		file:close()
	end
end, COM_ADMIN)

//HUD Drawing
local function drawSASSHud(v, p, camera)
	if not(p.mo and p.mo.valid and (sassabilities1.value or sassabilities2.value))
	or(p.powers[pw_carry] == CR_NIGHTSMODE)
		return
	end
	
	if sassabilities1.value or sassabilities2.value
		if p.skincolor == SKINCOLOR_FLOWINGLAVA
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS1"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif p.skincolor == SKINCOLOR_ACTIVENITRO
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS2"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif p.skincolor == SKINCOLOR_BEEPATTERN
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS3"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif p.skincolor == SKINCOLOR_DEEPSEA
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS4"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif p.skincolor == SKINCOLOR_TOXICRADIATION
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS5"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif p.skincolor == SKINCOLOR_PEPPERMINTCANDY
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS6"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif p.skincolor == SKINCOLOR_GOATHORN
			v.drawScaled(16*FRACUNIT, 158*FRACUNIT, FRACUNIT/2, v.cachePatch("SASS7"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		end
	end
end
hud.add(drawSASSHud, "game")

//Ability Visual freeslotting
freeslot(
"SPR_NIFS", "MT_NITROFIRESMALL", "S_NITROFIRESMALL",
"SPR_NIFN", "MT_NITROFIREMINI", "S_NITROFIREMINI",
"SPR_NIFM", "MT_NITROFIREMEDIUM", "S_NITROFIREMEDIUM",
"SPR_NIFL", "MT_NITROFIRELARGE", "S_NITROFIRELARGE",
"SPR_NIRI", "MT_NITRORING", "S_NITRORING",
"SPR_HAFI", "MT_HARMLESSFIRE", "S_HARMLESSFIRE",
"SPR_SWET", "MT_SWEAT", "S_SWEAT",
"SPR_SUIT", "MT_SUIT", "S_SUIT",
"SPR_DSBU", "MT_WSBUBBLE", "S_WSBUBBLE",
"SPR_TRCL", "MT_TRCLOUD", "S_TRCLOUD"
)

mobjinfo[MT_NITROFIREMINI] = {
	doomednum = -1,
	spawnstate = S_NITROFIREMINI,
	deathstate = S_NITROFIREMINI,
	spawnhealth = 1000,
	reactiontime = 9,
	radius = 3*FRACUNIT,
	height = 6*FRACUNIT,
	flags = MF_SCENERY|MF_SPECIAL|MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_NITROFIRESMALL] = {
	doomednum = -1,
	spawnstate = S_NITROFIRESMALL,
	deathstate = S_NITROFIRESMALL,
	spawnhealth = 1000,
	reactiontime = 9,
	radius = 10*FRACUNIT,
	height = 13*FRACUNIT,
	flags = MF_SCENERY|MF_SPECIAL|MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_NITROFIREMEDIUM] = {
	doomednum = -1,
	spawnstate = S_NITROFIREMEDIUM,
	deathstate = S_NITROFIREMEDIUM,
	spawnhealth = 1000,
	reactiontime = 9,
	radius = 18*FRACUNIT,
	height = 22*FRACUNIT,
	flags = MF_SCENERY|MF_SPECIAL|MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_NITROFIRELARGE] = {
	doomednum = -1,
	spawnstate = S_NITROFIRELARGE,
	deathstate = S_NITROFIRELARGE,
	spawnhealth = 1000,
	reactiontime = 9,
	speed = 5*FRACUNIT,
	radius = 26,
	height = 40,
	flags = MF_SCENERY|MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_NITRORING] = {
	doomednum = -1,
	spawnstate = S_NITRORING,
	deathstate = S_NITRORING,
	spawnhealth = 1000,
	reactiontime = 9,
	speed = 5*FRACUNIT,
	radius = 1,
	height = 1,
	flags = MF_SCENERY|MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_HARMLESSFIRE] = {
	doomednum = -1,
	spawnstate = S_HARMLESSFIRE,
	deathstate = S_HARMLESSFIRE,
	spawnhealth = 1000,
	reactiontime = 9,
	speed = 5*FRACUNIT,
	radius = 1,
	height = 1,
	flags = MF_SCENERY|MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_SWEAT] = {
	doomednum = -1,
	spawnstate = S_SWEAT,
	deathstate = S_SWEAT,
	spawnhealth = 1000,
	reactiontime = 9,
	speed = 5*FRACUNIT,
	radius = 1,
	height = 1,
	flags = MF_SCENERY|MF_SLIDEME
}
mobjinfo[MT_SUIT] = {
	doomednum = -1,
	spawnstate = S_SUIT,
	deathstate = S_SUIT,
	spawnhealth = 1,
	reactiontime = 1,
	speed = 5*FRACUNIT,
	radius = 20*FRACUNIT,
	height = 27*FRACUNIT,
	flags = MF_SOLID
}
mobjinfo[MT_WSBUBBLE] = {
	doomednum = -1,
	spawnstate = S_WSBUBBLE,
	deathstate = S_WSBUBBLE,
	spawnhealth = 1,
	reactiontime = 1,
	speed = 5*FRACUNIT,
	radius = 1*FRACUNIT,
	height = 1,
	flags = MF_SLIDEME|MF_NOGRAVITY
}
mobjinfo[MT_TRCLOUD] = {
	doomednum = -1,
	spawnstate = S_TRCLOUD,
	deathstate = S_TRCLOUD,
	spawnhealth = 1,
	reactiontime = 1,
	speed = 5*FRACUNIT,
	radius = 1*FRACUNIT,
	height = 1,
	flags = MF_SLIDEME|MF_NOGRAVITY
}

states[S_NITROFIREMINI] = {SPR_NIFN, A, -1, nil, 0, 0, S_NITROFIREMINI}
states[S_NITROFIRESMALL] = {SPR_NIFS, A|FF_ANIMATE, -1, nil, 1, 2, S_NITROFIRESMALL}
states[S_NITROFIREMEDIUM] = {SPR_NIFM, A|FF_ANIMATE, -1, nil, 1, 2, S_NITROFIREMEDIUM}
states[S_NITROFIRELARGE] = {SPR_NIFL, A|FF_ANIMATE, -1, nil, 2, 3, S_NITROFIRELARGE}
states[S_NITRORING] = {SPR_NIRI, A, -1, nil, 0, 0, S_NITRORING}
states[S_HARMLESSFIRE] = {SPR_HAFI, A|FF_ANIMATE, -1, nil, 1, 2, S_HARMLESSFIRE}
states[S_SWEAT] = {SPR_SWET, A, -1, nil, 0, 0, S_SWEAT}
states[S_SUIT] = {SPR_SUIT, A, -1, nil, 0, 0, S_SUIT}
states[S_WSBUBBLE] = {SPR_DSBU, A, -1, nil, 0, 0, S_WSBUBBLE}
states[S_TRCLOUD] = {SPR_TRCL, A, -1, nil, 0, 0, S_TRCLOUD}

addHook("MobjThinker", function(mo)
	if mo.nitrotimer == nil
		mo.nitrotimer = 0
	end

	mo.nitrotimer = $ + 1

	if mo.nitrotimer == 4
		mo.frame = FF_TRANS60
	end
	
	if mo.nitrotimer > 7
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_NITROFIREMINI)

addHook("MobjThinker", function(mo)
	if mo.nitrotimer == nil
		mo.nitrotimer = 0
	end

	mo.nitrotimer = $ + 1

	if mo.nitrotimer == 8
		mo.frame = FF_TRANS60
	end
	
	if mo.nitrotimer > 11
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_NITROFIRESMALL)

addHook("MobjThinker", function(mo)
	if mo.nitrotimer == nil
		mo.nitrotimer = 0
	end

	mo.nitrotimer = $ + 1

	if mo.nitrotimer == 12
		mo.frame = FF_TRANS60
	end
	
	if mo.nitrotimer > 15
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_NITROFIREMEDIUM)
addHook("MobjThinker", function(mo)
	if mo.nitrotimer == nil
		mo.nitrotimer = 0
	end

	mo.nitrotimer = $ + 1

	if mo.nitrotimer == 16
		mo.frame = FF_TRANS60
	end
	
	if mo.nitrotimer > 19
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_NITROFIRELARGE)
addHook("MobjThinker", function(mo)
	mo.scale = $*14/13
	
	if mo.nitrotimer == nil
		mo.nitrotimer = 0
	end

	mo.nitrotimer = $ + 1
	mo.frame = (mo.nitrotimer<<FF_TRANSSHIFT)
	
	if mo.nitrotimer == 9
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_NITRORING)
addHook("MobjThinker", function(mo)
	mo.scale = $*14/13
	
	if mo.firetimer == nil
		mo.firetimer = 0
	end
	
	mo.firetimer = $ + 1

	if mo.firetimer == 7
	mo.frame = (mo.firetimer<<FF_TRANSSHIFT)
	end
	
	if mo.firetimer == 9
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_HARMLESSFIRE)
addHook("MobjThinker", function(mo)
	if mo.sweattimer == nil
		mo.sweattimer = 0
	end

	mo.sweattimer = $ + 1
	mo.frame = (mo.sweattimer<<FF_TRANSSHIFT)
	
	if mo.sweattimer == 9
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_SWEAT)
addHook("MobjThinker", function(mo)
	if mo.bubbletimer == nil
		mo.bubbletimer = 0
	end

	mo.bubbletimer = $ + 1
	mo.frame = (mo.bubbletimer<<FF_TRANSSHIFT)
	
	if mo.bubbletimer == 9
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_WSBUBBLE)
addHook("MobjThinker", function(mo)
	if mo.cloudtimer == nil
		mo.cloudtimer = 0
	end
	
	mo.scale = $*14/13

	mo.cloudtimer = $ + 1
	mo.frame = (mo.cloudtimer<<FF_TRANSSHIFT)
	
	if mo.cloudtimer == 9
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_TRCLOUD)
addHook("MobjThinker", function(mo)
	if mo.suittimer == nil
		mo.suittimer = 0
	end

	mo.suittimer = $ + 1
	
	if mo.suittimer == 200
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 205
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 210
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 215
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 220
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 224
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 228
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 232
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 236
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 239
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 242
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 244
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 246
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 247
		mo.flags = $ &~MF2_DONTDRAW
	elseif mo.suittimer == 248
		mo.flags = $|MF2_DONTDRAW
	elseif mo.suittimer == 249
		mo.flags = $ &~MF2_DONTDRAW
	end

	if mo.suittimer == 250
		P_KillMobj(mo)
		mo.state = S_NULL
	end
end, MT_SUIT)

freeslot("sfx_sshb")
sfxinfo[sfx_sshb] = {flags = SF_X4AWAYSOUND}
sfxinfo[sfx_sshb].caption = "Horn Blowing"

//Ways to earn some SASS in:
addHook("MobjDeath", function(target, inflictor, source)
    if source
    and source.player
    and (target.flags & MF_ENEMY)
	and sasspickup.value
		local SASScolor = 0
		//singleplayer/splitscreen/coop - By beating badniks
		if gametype == GT_COOP or (gametyperules&GTR_RACE) then
			SASScolor = P_RandomRange(1, 10)
			if SASScolor == 1 and source.player.skincolor ~= SKINCOLOR_ACTIVENITRO
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = B
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 2 and source.player.skincolor ~= SKINCOLOR_FLOWINGLAVA
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = A
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 3 and source.player.skincolor ~= SKINCOLOR_BEEPATTERN
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = C
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 4 and source.player.skincolor ~= SKINCOLOR_DEEPSEA
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = D
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 5 and source.player.skincolor ~= SKINCOLOR_TOXICRADIATION
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = E
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 6 and source.player.skincolor ~= SKINCOLOR_PEPPERMINTCANDY
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = F
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 7 and source.player.skincolor ~= SKINCOLOR_GOATHORN
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = G
				Suit.scale = Suit.scale*3/4
			end
		end
	end
end)
addHook("MobjDeath", function(target, inflictor, source)
    if source
    and source.player
    and (target.flags & MF_MONITOR)
	and sasspickup.value
		local SASScolor = 0
		//race/competition - By beating monitors
		if (gametyperules&GTR_RACE) then
			SASScolor = P_RandomRange(1, 10)
			if SASScolor == 1 and source.player.skincolor ~= SKINCOLOR_ACTIVENITRO
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = B
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 2 and source.player.skincolor ~= SKINCOLOR_FLOWINGLAVA
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = A
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 3 and source.player.skincolor ~= SKINCOLOR_BEEPATTERN
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = C
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 4  and source.player.skincolor ~= SKINCOLOR_DEEPSEA
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = D
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 5  and source.player.skincolor ~= SKINCOLOR_TOXICRADIATION
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = E
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 6 and source.player.skincolor ~= SKINCOLOR_PEPPERMINTCANDY
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = F
				Suit.scale = Suit.scale*3/4
			elseif SASScolor == 7 and source.player.skincolor ~= SKINCOLOR_GOATHORN
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 3*FRACUNIT, true)
				Suit.frame = G
				Suit.scale = Suit.scale*3/4
			end
		end
	end
end)

addHook("MobjCollide", function(Suit, p)
	if p
	and p.player
	and Suit.type == MT_SUIT
	and not (p.player.mo.state == S_PLAY_DRWN or p.player.mo.state == S_PLAY_DEAD or p.player.mo.state == S_PLAY_PAIN)
	and p.z <= Suit.z + Suit.height and p.z + p.height >= Suit.z
		P_SpawnMobjFromMobj(Suit,0,0,0,MT_SPARK)
		local spark = P_SpawnMobj(p.player.mo.x, p.player.mo.y, p.player.mo.z - (1 * p.player.mo.height)/2, MT_SUPERSPARK)
		spark.scale = 2 * p.player.mo.scale
		if Suit.frame == A
			if sassswitch.value
				p.player.FLOwned = 1
			end
			p.player.skincolor = SKINCOLOR_FLOWINGLAVA
			p.player.mo.color = SKINCOLOR_FLOWINGLAVA
			p.player.FLPickup = 1
			p.player.ANPickup = 0
			p.player.BPPickup = 0
			p.player.DSPickup = 0
			p.player.TRPickup = 0
			p.player.PCPickup = 0
			p.player.GHPickup = 0
		elseif Suit.frame == B
			p.player.skincolor = SKINCOLOR_ACTIVENITRO
			p.player.mo.color = SKINCOLOR_ACTIVENITRO
			if sassswitch.value
				p.player.ANOwned = 1
			end
			p.player.FLPickup = 0
			p.player.ANPickup = 1
			p.player.BPPickup = 0
			p.player.DSPickup = 0
			p.player.TRPickup = 0
			p.player.PCPickup = 0
			p.player.GHPickup = 0
		elseif Suit.frame == C
			if sassswitch.value
				p.player.BPOwned = 1
			end
			p.player.skincolor = SKINCOLOR_BEEPATTERN
			p.player.mo.color = SKINCOLOR_BEEPATTERN
			p.player.FLPickup = 0
			p.player.ANPickup = 0
			p.player.BPPickup = 1
			p.player.DSPickup = 0
			p.player.TRPickup = 0
			p.player.PCPickup = 0
			p.player.GHPickup = 0
		elseif Suit.frame == D
			if sassswitch.value
				p.player.DSOwned = 1
			end
			p.player.skincolor = SKINCOLOR_DEEPSEA
			p.player.mo.color = SKINCOLOR_DEEPSEA
			p.player.FLPickup = 0
			p.player.ANPickup = 0
			p.player.BPPickup = 0
			p.player.DSPickup = 1
			p.player.TRPickup = 0
			p.player.PCPickup = 0
			p.player.GHPickup = 0
		elseif Suit.frame == E
			p.player.TROwned = 1
			p.player.skincolor = SKINCOLOR_TOXICRADIATION
			p.player.mo.color = SKINCOLOR_TOXICRADIATION
			p.player.FLPickup = 0
			p.player.ANPickup = 0
			p.player.BPPickup = 0
			p.player.DSPickup = 0
			p.player.TRPickup = 1
			p.player.PCPickup = 0
			p.player.GHPickup = 0
		elseif Suit.frame == F
			if sassswitch.value
				p.player.PCOwned = 1
			end
			p.player.skincolor = SKINCOLOR_PEPPERMINTCANDY
			p.player.mo.color = SKINCOLOR_PEPPERMINTCANDY
			p.player.FLPickup = 0
			p.player.ANPickup = 0
			p.player.BPPickup = 0
			p.player.DSPickup = 0
			p.player.TRPickup = 0
			p.player.PCPickup = 1
			p.player.GHPickup = 0
		elseif Suit.frame == G
			if sassswitch.value
				p.player.GHOwned = 1
			end
			p.player.skincolor = SKINCOLOR_GOATHORN
			p.player.mo.color = SKINCOLOR_GOATHORN
			p.player.FLPickup = 0
			p.player.ANPickup = 0
			p.player.BPPickup = 0
			p.player.DSPickup = 0
			p.player.TRPickup = 0
			p.player.PCPickup = 0
			p.player.GHPickup = 1
		end
		S_StartSound(p.player.mo, sfx_token)
		P_KillMobj(Suit, p, p)
		Suit.state = S_NULL
	end
end, MT_SUIT)

//Match/Team Match/CTF - by beating the shit out of the players!
addHook("MobjDamage", function(target, inflictor, source)
    if source
    and source.player
    and target
	and target.player
	and sasspickup.value
		local SASScolor = 0
		if (gametyperules & GTR_RINGSLINGER) or CWB_Battle then
			if not (target.player.skincolor == SKINCOLOR_FLOWINGLAVA or target.player.skincolor == SKINCOLOR_ACTIVENITRO or target.player.skincolor == SKINCOLOR_BEEPATTERN
			or target.player.skincolor == SKINCOLOR_DEEPSEA or target.player.skincolor == SKINCOLOR_TOXICRADIATION
			or target.player.skincolor == SKINCOLOR_PEPPERMINTCANDY or target.player.skincolor == SKINCOLOR_GOATHORN)
				SASScolor = P_RandomRange(1, 10)
				if SASScolor == 1  and source.player.skincolor ~= SKINCOLOR_ACTIVENITRO
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = B
					Suit.scale = Suit.scale*3/4
				elseif SASScolor == 2 and source.player.skincolor ~= SKINCOLOR_FLOWINGLAVA
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = A
					Suit.scale = Suit.scale*3/4
				elseif SASScolor == 3 and source.player.skincolor ~= SKINCOLOR_BEEPATTERN
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = C
					Suit.scale = Suit.scale*3/4
				elseif SASScolor == 4 and source.player.skincolor ~= SKINCOLOR_DEEPSEA
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = D
					Suit.scale = Suit.scale*3/4
				elseif SASScolor == 5 and source.player.skincolor ~= SKINCOLOR_TOXICRADIATION
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = E
					Suit.scale = Suit.scale*3/4
				elseif SASScolor == 6 and source.player.skincolor ~= SKINCOLOR_PEPPERMINTCANDY
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = F
					Suit.scale = Suit.scale*3/4
				elseif SASScolor == 7 and source.player.skincolor ~= SKINCOLOR_GOATHORN
					local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
					P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
					Suit.frame = G
					Suit.scale = Suit.scale*3/4
				end
			elseif target.player.skincolor == SKINCOLOR_FLOWINGLAVA
				target.player.FLOwned = 0
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = A
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.FLPickup = 0
			elseif target.player.skincolor == SKINCOLOR_ACTIVENITRO
				target.player.ANOwned = 0
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = B
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.ANPickup = 0
			elseif target.player.skincolor == SKINCOLOR_BEEPATTERN
				target.player.BPOwned = 1
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = C
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.BPPickup = 0
			elseif target.player.skincolor == SKINCOLOR_DEEPSEA
				target.player.DSOwned = 1
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = D
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.DSPickup = 0
			elseif target.player.skincolor == SKINCOLOR_TOXICRADIATION
				target.player.TROwned = 1
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = E
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.TRPickup = 0
			elseif target.player.skincolor == SKINCOLOR_PEPPERMINTCANDY
				target.player.PCOwned = 1
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = F
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.PCPickup = 0
			elseif target.player.skincolor == SKINCOLOR_GOATHORN
				target.player.GHOwned = 1
				local Suit = P_SpawnMobjFromMobj(target,0,0,-1/2*FRACUNIT,MT_SUIT)
				P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
				Suit.frame = G
				Suit.scale = Suit.scale*3/4
				if not (gametyperules & GTR_TEAMS)
					target.player.skincolor = skins[target.player.mo.skin].prefcolor
					target.player.mo.color = skins[target.player.mo.skin].prefcolor
				elseif (gametyperules & GTR_TEAMS)
					if target.player.ctfteam == 1
						target.player.skincolor = SKINCOLOR_RED
						target.player.mo.color = SKINCOLOR_RED
					elseif target.player.ctfteam == 2
						target.player.skincolor = SKINCOLOR_BLUE
						target.player.mo.color = SKINCOLOR_BLUE
					end
				end
				target.player.GHPickup = 0
			end
		end
	end
end, MT_PLAYER)

//checkpoints (way more rare then with other stuff)
local function SASSCheckpointReward(post, mo)
	local player = mo.player
	if player.starpostnum < post.health and sasscheckpoint.value
	and post.state == S_STARPOST_IDLE
		local SASScolor = P_RandomRange(1, 14)
		if SASScolor == 1 and player.skincolor ~= SKINCOLOR_ACTIVENITRO
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = B
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		elseif SASScolor == 2 and player.skincolor ~= SKINCOLOR_FLOWINGLAVA
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = A
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		elseif SASScolor == 3 and player.skincolor ~= SKINCOLOR_BEEPATTERN
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = C
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		elseif SASScolor == 4  and player.skincolor ~= SKINCOLOR_DEEPSEA
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = D
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		elseif SASScolor == 5  and player.skincolor ~= SKINCOLOR_TOXICRADIATION
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = E
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		elseif SASScolor == 6  and player.skincolor ~= SKINCOLOR_PEPPERMINTCANDY
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = F
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		elseif SASScolor == 7  and player.skincolor ~= SKINCOLOR_GOATHORN
			P_SpawnMobjFromMobj(post,0,0,post.height,MT_SPARK)
			local Suit = P_SpawnMobjFromMobj(post,0,0,post.height,MT_SUIT)
			P_SetObjectMomZ(Suit, 5*FRACUNIT, true)
			Suit.frame = G
			Suit.scale = Suit.scale*3/4
			S_StartSoundAtVolume(post, sfx_monton, 200)
		end
	end
end
addHook("TouchSpecial", SASSCheckpointReward, MT_STARPOST)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not p.mo and p.valid
			return
		end
		
		if not (p.cmd.buttons&BT_JUMP) and (p.pflags&PF_STARTJUMP)
			p.pflags = $ &~PF_STARTJUMP
		end
		
		//revert back to normal if you are dead with skinabilities on
		if p.mo.state == S_PLAY_DEAD or p.mo.state == S_PLAY_DRWN
			if sassdeath.value
				p.FLOwned = 0
				p.ANOwned = 0
				p.BPOwned = 0
				p.DSOwned = 0
				p.TROwned = 0
				p.PCOwned = 0
				p.GHOwned = 0
				SASSGotAll = 0
			end
		
			if sassdeath.value
			and (p.skincolor == SKINCOLOR_FLOWINGLAVA or p.skincolor == SKINCOLOR_ACTIVENITRO or p.skincolor == SKINCOLOR_BEEPATTERN
			or p.skincolor == SKINCOLOR_DEEPSEA or p.skincolor == SKINCOLOR_TOXICRADIATION
			or p.skincolor == SKINCOLOR_PEPPERMINTCANDY or p.skincolor == SKINCOLOR_GOATHORN)
				if not (gametyperules & GTR_TEAMS)
					p.skincolor = skins[p.mo.skin].prefcolor
					p.mo.color = skins[p.mo.skin].prefcolor
				else
					if p.ctfteam == 1
						p.skincolor = SKINCOLOR_RED
						p.mo.color = SKINCOLOR_RED
					elseif p.ctfteam == 2
						p.skincolor = SKINCOLOR_BLUE
						p.mo.color = SKINCOLOR_BLUE
					end
				end
				p.FLPickup = 0
				p.ANPickup = 0
				p.BPPickup = 0
				p.DSPickup = 0
				p.TRPickup = 0
				p.PCPickup = 0
			end
		end
		if p.FLPickup == nil
			p.FLPickup = 0
		end
		//revert back to normal if you on game over with skinswitch on
		if (not p.mo and not p.valid) 
		and ((gametyperules & GTR_TEAMS) or (gametyperules & GTR_RINGSLINGER) or CWB_Battle)
			p.FLOwned = 0
			p.ANOwned = 0
			p.BPOwned = 0
			p.DSOwned = 0
			p.TROwned = 0
			p.PCOwned = 0
			p.GHOwned = 0
		end
		
		if p.ANPickup == nil
			p.ANPickup = 0
		end
		if p.BPPickup == nil
			p.BPPickup = 0
		end
		if p.DSPickup == nil
			p.DSPickup = 0
		end
		if p.TRPickup == nil
			p.TRPickup = 0
		end
		if p.PCPickup == nil
			p.PCPickup = 0
		end
		if sassban.value
			if p.BPPickup == 0 
				if p.skincolor == SKINCOLOR_BEEPATTERN
				and not p.BPOwned
					p.skincolor = skins[p.mo.skin].prefcolor
					p.mo.color = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.ANPickup = 0
					p.FLPickup = 0
					p.DSPickup = 0
					p.TRPickup = 0
					p.PCPickup = 0
					p.GHPickup = 0
				end
			end
		end
		if sassban.value
			if p.ANPickup == 0 
				if p.skincolor == SKINCOLOR_ACTIVENITRO
				and not p.ANOwned
					p.skincolor = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.mo.color = skins[p.mo.skin].prefcolor
					p.BPPickup = 0
					p.FLPickup = 0
					p.DSPickup = 0
					p.TRPickup = 0
					p.PCPickup = 0
					p.GHPickup = 0
				end
			end
		end
		if sassban.value
			if p.FLPickup == 0 
				if p.skincolor == SKINCOLOR_FLOWINGLAVA
				and not p.FLOwned
					p.skincolor = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.mo.color = skins[p.mo.skin].prefcolor
					p.BPPickup = 0
					p.ANPickup = 0
					p.DSPickup = 0
					p.TRPickup = 0
					p.PCPickup = 0
					p.GHPickup = 0
				end
			end
		end
		if sassban.value
			if p.DSPickup == 0 
				if p.skincolor == SKINCOLOR_DEEPSEA
				and not p.DSOwned
					p.skincolor = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.mo.color = skins[p.mo.skin].prefcolor
					p.BPPickup = 0
					p.ANPickup = 0
					p.FLPickup = 0
					p.TRPickup = 0
					p.PCPickup = 0
					p.GHPickup = 0
				end
			end
		end
		if sassban.value
			if p.TRPickup == 0 
				if p.skincolor == SKINCOLOR_TOXICRADIATION
				and not p.TROwned
					p.skincolor = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.mo.color = skins[p.mo.skin].prefcolor
					p.BPPickup = 0
					p.ANPickup = 0
					p.FLPickup = 0
					p.DSPickup = 0
					p.PCPickup = 0
					p.GHPickup = 0
				end
			end
		end
		if sassban.value
			if p.PCPickup == 0 
				if p.skincolor == SKINCOLOR_PEPPERMINTCANDY
				and not p.PCOwned
					p.skincolor = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.mo.color = skins[p.mo.skin].prefcolor
					p.BPPickup = 0
					p.ANPickup = 0
					p.FLPickup = 0
					p.DSPickup = 0
					p.TRPickup = 0
					p.GHPickup = 0
				end
			end
		end
		if sassban.value
			if p.GHPickup == 0 
				if p.skincolor == SKINCOLOR_GOATHORN
				and not p.GHOwned
					p.skincolor = skins[p.mo.skin].prefcolor
					CONS_Printf(p,"Sorry, but \x82SASS colors\x80 aren't allowed to be accessed directly with \x82sass_ban on\x80.")
					p.mo.color = skins[p.mo.skin].prefcolor
					p.BPPickup = 0
					p.ANPickup = 0
					p.FLPickup = 0
					p.DSPickup = 0
					p.TRPickup = 0
					p.PCPickup = 0
				end
			end
		end
	end
end)

addHook("MapLoad", function()
	for p in players.iterate do
		if SASSMenu
			p.pflags = $|PF_USEDOWN & ~PF_INVIS & ~PF_GODMODE & ~PF_FORCESTRAFE & ~PF_STARTDASH & ~PF_SPINNING & ~PF_JUMPED & ~PF_STASIS & ~PF_JUMPSTASIS & ~PF_THOKKED
			SASSMenu = 0
			SASSMenuTimeout = 5
			SASSChoice = 0
			SASSPage = 0
		end
		if not (gametyperules&GTR_FRIENDLY) and multiplayer and (sassabilities1.value or sassabilities2.value)
		and (p.skincolor == SKINCOLOR_FLOWINGLAVA or p.skincolor == SKINCOLOR_ACTIVENITRO or p.skincolor == SKINCOLOR_BEEPATTERN
		or p.skincolor == SKINCOLOR_DEEPSEA or p.skincolor == SKINCOLOR_TOXICRADIATION or p.skincolor == SKINCOLOR_PEPPERMINTCANDY
		or p.skincolor == SKINCOLOR_GOATHORN)
			if not (gametyperules & GTR_TEAMS)
				p.skincolor = skins[p.mo.skin].prefcolor
				p.mo.color = skins[p.mo.skin].prefcolor
			else
				if p.ctfteam == 1
					p.skincolor = SKINCOLOR_RED
					p.mo.color = SKINCOLOR_RED
				elseif p.ctfteam == 2
					p.skincolor = SKINCOLOR_BLUE
					p.mo.color = SKINCOLOR_BLUE
				end
			end
			p.BPPickup = 0
			p.FLPickup = 0
			p.ANPickup = 0
			p.DSPickup = 0
			p.TRPickup = 0
			p.PCPickup = 0
			p.GHPickup = 0
		end
    end
end)

//SKINCOLOR - FLOWING LAVA
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
//Main ability - Lava Burst
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end

		if p.skincolor == SKINCOLOR_FLOWINGLAVA and sassabilities1.value and (p.pflags&PF_JUMPED) and not (p.pflags&PF_STARTJUMP)
		and (p.mo.state == S_PLAY_JUMP or p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL) and not p.LavaBurstActivated  //Set all alterable values for this specific skincolor
		and (p.cmd.buttons&BT_CUSTOM1) and not (p.pflags&PF_FINISHED) and p.sassspun == 0 and p.mo.state != S_PLAY_GLIDE then
			P_SetObjectMomZ(p.mo, 0, false) //Cancel Z movement
			if leveltime % 2
				S_StartSoundAtVolume(p.mo, 	sfx_s1ae, 8*p.LavaBurstTimer)
			end
			p.LavaBurstTimer = $+1 //Increase a timer by 1 per tick
		end
		
		if p.skincolor ~= SKINCOLOR_FLOWINGLAVA or (p.mo.state ~= S_PLAY_JUMP and not (p.pflags&PF_JUMPED) and p.powers[pw_carry] ~= CR_NONE)
		or p.mo.state == S_PLAY_SPRING or not (p.pflags&PF_JUMPED) or p.mo.state == S_PLAY_RIDE
		or p.powers[pw_carry] ~= CR_NONE// Cancel any values
			p.LavaBurstActivated = 0	
			p.LavaBurstTimer = 0
		end
		
		if P_IsObjectOnGround(p.mo)
			p.sassspun = 0
		end
		
		if (p.pflags&PF_SHIELDABILITY) and not p.LavaBurstActivated
			p.LavaBurstActivated = 1
		end

		if p.LavaBurstTimer > 0 and not p.LavaBurstActivated and sassvisuals.value
			local rock = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_LAVAFALLROCK)
			P_InstaThrust(rock, P_RandomRange(1,16)*ANGLE_22h, p.LavaBurstTimer*p.mo.scale)
			rock.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			local BurstFlame = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_HARMLESSFIRE)
			P_SetObjectMomZ(BurstFlame, p.LavaBurstTimer*FRACUNIT + P_RandomRange(p.LavaBurstTimer/5,p.LavaBurstTimer/2)*FRACUNIT, true)
			BurstFlame.scale = p.mo.scale/2
			BurstFlame.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
		end
		if p.LavaBurstTimer > 15 and not p.LavaBurstActivated and sassvisuals.value
			local rock = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_LAVAFALLROCK)
			local lavarock = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_ROCKCRUMBLE5)
			P_InstaThrust(rock, P_RandomRange(1,16)*ANGLE_22h, p.LavaBurstTimer*p.mo.scale)
			P_InstaThrust(lavarock, P_RandomRange(1,16)*ANGLE_22h, p.LavaBurstTimer/2*p.mo.scale)
			rock.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			lavarock.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			local BurstFlame = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_HARMLESSFIRE)
			P_SetObjectMomZ(BurstFlame, p.LavaBurstTimer*FRACUNIT + P_RandomRange(p.LavaBurstTimer/5,p.LavaBurstTimer/2)*FRACUNIT, true)
			BurstFlame.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
		end
		if sassvisuals.value and ((p.LavaBurstTimer > 0 and not p.LavaBurstActivated and not (p.cmd.buttons&BT_CUSTOM1))
		or (p.LavaBurstTimer > 30 and not p.LavaBurstActivated))
			local LavaBurst = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_LAVASPLISH)
			LavaBurst.scale = p.LavaBurstTimer / 5 * p.mo.scale
			LavaBurst.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
		end

		if p.skincolor == SKINCOLOR_FLOWINGLAVA
		and (p.pflags&PF_JUMPED) and not p.LavaBurstActivated
		and ((p.LavaBurstTimer > 0 and not (p.cmd.buttons&BT_CUSTOM1)) or p.LavaBurstTimer > 30) then
			p.LavaBurstActivated = true
			S_StartSoundAtVolume(p.mo, sfx_s3k7a, 8*p.LavaBurstTimer)
			S_StartSoundAtVolume(p.mo, sfx_splash, 8*p.LavaBurstTimer)
			S_StartSoundAtVolume(p.mo, sfx_s24b, 8*p.LavaBurstTimer)
			if not (p.mo.eflags & MFE_UNDERWATER)
				if not p.powers[pw_super]
					P_SetObjectMomZ(p.mo, p.LavaBurstTimer*FRACUNIT, false)
				else 
					P_SetObjectMomZ(p.mo, p.LavaBurstTimer*FRACUNIT*2, false)
				end
			else
				if not p.powers[pw_super]
					P_SetObjectMomZ(p.mo, p.LavaBurstTimer*FRACUNIT/2, false)
				else
					P_SetObjectMomZ(p.mo, p.LavaBurstTimer*FRACUNIT, false)
				end
			end
		end
	end
end)
//Secondary ability - Invincibility to fire and lava
 addHook("ShouldDamage", function(target, inflictor, source, damage)
    if target.player.skincolor == SKINCOLOR_FLOWINGLAVA and sassabilities2.value and target.player.mo   // Invincibility to:
        if (inflictor and inflictor.flags & MF_FIRE) or (source and source.flags & MF_FIRE) // Fire
            return false
        end
        if not inflictor and not source and P_PlayerTouchingSectorSpecial(target.player, 1, 3) // Lava
            return false
        end
    end
end, MT_PLAYER)


//SKINCOLOR - ACTIVE NITRO
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
//Main ability - Bullet Charge
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end
		if p.skincolor == SKINCOLOR_ACTIVENITRO and (p.pflags&PF_JUMPED) and sassabilities1.value and p.sassspun == 0 and not (p.pflags&PF_STARTJUMP)
		and (p.cmd.buttons&BT_CUSTOM1) and p.BulletChargeWallBonk == 0 and not (p.pflags&PF_FINISHED) then //Set all alterable values for this specific skincolor
			if p.BulletChargeUses <= 3
				P_SetObjectMomZ(p.mo, 0, false) //Cancel Z movement
				if not (p.mo.eflags & MFE_UNDERWATER) and not p.powers[pw_super]  //thrust player exponentially as camera controls it
					P_Thrust(p.mo, p.mo.angle, 1*FRACUNIT)
				elseif (p.mo.eflags & MFE_UNDERWATER) and not p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle, 1*FRACUNIT/2)
				elseif not (p.mo.eflags & MFE_UNDERWATER) and p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle, 2*FRACUNIT)
				elseif (p.mo.eflags & MFE_UNDERWATER) and p.powers[pw_super]
					P_Thrust(p.mo, p.mo.angle, 1*FRACUNIT)
				end
				p.BulletChargeActivated = 1
				p.powers[pw_nocontrol] = 0
				p.drawangle = p.mo.angle
			end
		end

		if p.skincolor == SKINCOLOR_ACTIVENITRO and p.BulletChargeActivated == 1
		and not(p.cmd.buttons&BT_CUSTOM1) and p.mo and not (p.pflags&PF_SHIELDABILITY)
			p.BulletChargeActivated = 0
			P_InstaThrust(p.mo, p.mo.angle, 12*FRACUNIT) //give a small speed boost
			p.BulletChargeUses = $+1 //make it so that you can use the ability 3 times
		end
		
		if p.skincolor ~= SKINCOLOR_ACTIVENITRO or (p.mo.state ~= S_PLAY_JUMP and p.mo.state ~= S_PLAY_FALL)
		or (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_PAIN or p.mo.state == S_PLAY_RIDE 
		or p.mo.state == S_PLAY_DEAD or p.mo.state == S_PLAY_DRWN) or not (p.pflags&PF_JUMPED)
		or not (p.mo and p.valid)//disable all values
			p.BulletChargeActivated = 0
			p.BulletChargeUses = 0
			p.BulletChargeWallBonk = 0
		end
		
		if P_IsObjectOnGround(p.mo)
			p.sassspun = 0
		end
		
		if p.skincolor == SKINCOLOR_ACTIVENITRO and (p.pflags&PF_SHIELDABILITY) and p.BulletChargeUses < 3
			p.BulletChargeUses = 4
			p.BulletChargeActivated = 0
		end

		if p.mo and p.valid
			if p.mo.state == S_PLAY_FALL and p.BulletChargeWallBonk == 1 
				if not(p.mo.eflags & MFE_VERTICALFLIP) and p.mo.momz <= -5
					p.BulletChargeWallBonk = 0
					p.mo.state = S_PLAY_JUMP
				elseif (p.mo.eflags & MFE_VERTICALFLIP) and p.mo.momz >= 5
					p.BulletChargeWallBonk = 0
					p.mo.state = S_PLAY_JUMP
				end
			end
		end
		
		if p.BulletChargeUses == 0 and p.BulletChargeActivated == 1 and p.skincolor == SKINCOLOR_ACTIVENITRO
			if leveltime % 2
				S_StartSoundAtVolume(p.mo, sfx_s3k43, 250)
				S_StartSoundAtVolume(p.mo, sfx_fire, 250)
			end
			if sassvisuals.value
				local NitroFireLarge = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1 * p.mo.height) / 2, MT_NITROFIRELARGE)
				P_SetObjectMomZ(NitroFireLarge, P_RandomRange(-7,7)*FRACUNIT, true)
				P_InstaThrust(NitroFireLarge, P_RandomRange(1,16)*ANGLE_22h, 5*p.mo.scale)
				NitroFireLarge.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			end
		elseif p.BulletChargeUses == 1 and p.BulletChargeActivated == 1 and p.skincolor == SKINCOLOR_ACTIVENITRO
			if leveltime % 2
				S_StartSoundAtVolume(p.mo, sfx_s3k43, 180)
				S_StartSoundAtVolume(p.mo, sfx_fire, 180)
			end
			if sassvisuals.value
				local NitroFireMedium = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1 * p.mo.height) / 2, MT_NITROFIREMEDIUM)
				P_SetObjectMomZ(NitroFireMedium, P_RandomRange(-5,5)*FRACUNIT, true)
				P_InstaThrust(NitroFireMedium, P_RandomRange(1,16)*ANGLE_22h, 4*p.mo.scale)
				NitroFireMedium.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			end
		elseif p.BulletChargeUses == 2 and p.BulletChargeActivated == 1 and p.skincolor == SKINCOLOR_ACTIVENITRO
			if leveltime % 2
				S_StartSoundAtVolume(p.mo, sfx_s3k43, 180)
			end
			if sassvisuals.value
				local NitroFireSmall = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1 * p.mo.height) / 2, MT_NITROFIRESMALL)
				P_SetObjectMomZ(NitroFireSmall, P_RandomRange(-3,3)*FRACUNIT, true)
				P_InstaThrust(NitroFireSmall, P_RandomRange(1,16)*ANGLE_22h, 3*p.mo.scale)
				NitroFireSmall.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			end
		elseif p.BulletChargeUses == 3 and p.BulletChargeActivated == 1 and p.skincolor == SKINCOLOR_ACTIVENITRO
			if leveltime % 2
				S_StartSoundAtVolume(p.mo, sfx_s3k43, 90)
			end
			if sassvisuals.value
				local NitroFireMini = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1 * p.mo.height) / 2, MT_NITROFIREMINI)
				P_SetObjectMomZ(NitroFireMini, P_RandomRange(-1,1)*FRACUNIT, true)
				P_InstaThrust(NitroFireMini, P_RandomRange(1,16)*ANGLE_22h, 2*p.mo.scale)
				NitroFireMini.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			end
		end
		
	
//Secondary ability - Increased acceleration and top speed	
		if p.skincolor == SKINCOLOR_ACTIVENITRO and sassabilities2.value and p.mo
			p.actionspd = skins[p.mo.skin].actionspd*5/4
			p.maxdash = skins[p.mo.skin].maxdash*7/5
				if p.normalspeed == skins[p.mo.skin].normalspeed
					p.normalspeed = skins[p.mo.skin].normalspeed*5/3
				end
			p.acceleration = skins[p.mo.skin].acceleration*6/4
		elseif p.skincolor ~= SKINCOLOR_ACTIVENITRO or not sassabilities2.value
			p.actionspd = skins[p.mo.skin].actionspd
			p.maxdash = skins[p.mo.skin].maxdash
				if p.normalspeed == skins[p.mo.skin].normalspeed*5/3
					p.normalspeed = skins[p.mo.skin].normalspeed
				end
			p.acceleration = skins[p.mo.skin].acceleration
		end
	end
end)

addHook("MobjMoveBlocked",function(p)
	if p.player.BulletChargeActivated == 1 and sassabilities1.value
		p.player.BulletChargeActivated = 0
		p.player.mo.state = S_PLAY_FALL
		p.player.BulletChargeWallBonk = 1
		P_BounceMove(p.player.mo)
		if sassvisuals.value
			P_SpawnMobj(p.player.mo.x, p.player.mo.y, p.player.mo.z + (1 * p.player.mo.height) / 2, MT_NITRORING)
		end
		p.player.BulletChargeUses = $+1 //make it so that you can use the ability 3 times
		if not (p.player.mo.eflags & MFE_UNDERWATER) and not p.player.powers[pw_super]  //Bounce off walls with some height
			P_SetObjectMomZ(p.player.mo, 9*FRACUNIT)
		elseif (p.player.mo.eflags & MFE_UNDERWATER) and not p.player.powers[pw_super]
			P_SetObjectMomZ(p.player.mo, 9*FRACUNIT/2)
		elseif not (p.player.mo.eflags & MFE_UNDERWATER) and p.player.powers[pw_super]
			P_SetObjectMomZ(p.player.mo, 18*FRACUNIT)
		elseif (p.player.mo.eflags & MFE_UNDERWATER) and p.player.powers[pw_super]
			P_SetObjectMomZ(p.player.mo, 9*FRACUNIT)
		end
		S_StartSound(p.player.mo, sfx_s3k49)
	end
end, MT_PLAYER)

//SKINCOLOR - BEE PATTERN
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
//Main ability - Bee Flight
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end
		if p.BeeFlightTimer == nil
			p.BeeFlightTimer = 0
		end
		if p.skincolor == SKINCOLOR_BEEPATTERN and (p.pflags&PF_JUMPED) and sassabilities1.value and p.mo.state ~= S_PLAY_GLIDE and not (p.pflags&PF_STARTJUMP)
		and (p.cmd.buttons&BT_CUSTOM1) and not (p.pflags&PF_FINISHED) and not (p.mo.eflags & MFE_UNDERWATER) and p.sassspun == 0 then
			if p.BeeFlightTimer < 100
				p.powers[pw_nocontrol] = 0
				P_SetObjectMomZ(p.mo, 1*FRACUNIT, true)
				if not p.powers[pw_super]
					if p.BeeFlightTimer > 1 and p.BeeFlightTimer < 25
						if leveltime % 3
							S_StartSoundAtVolume(p.mo, sfx_buzz4, 250)
						end
						if sassvisuals.value
							local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
							P_InstaThrust(Sweat, P_RandomRange(1,16)*ANGLE_22h, 4*p.mo.scale)
							Sweat.angle = FixedAngle(p.mo.angle)
							Sweat.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
						end
					elseif p.BeeFlightTimer > 25 and p.BeeFlightTimer < 50
						if leveltime % 3
							S_StartSoundAtVolume(p.mo, sfx_buzz4, 200)
						end
						if sassvisuals.value
							local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
							P_InstaThrust(Sweat, P_RandomRange(1,16)*ANGLE_22h, 4*p.mo.scale)
							Sweat.angle = FixedAngle(p.mo.angle)
							Sweat.scale = 3/2 * p.mo.scale
							Sweat.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
						end
					elseif p.BeeFlightTimer > 50 and p.BeeFlightTimer < 75
						if leveltime % 3
							S_StartSoundAtVolume(p.mo, sfx_buzz4, 150)
						end
						if sassvisuals.value
							local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
							local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
							P_InstaThrust(Sweat, P_RandomRange(1,16)*ANGLE_22h, 4*p.mo.scale)
							Sweat.angle = FixedAngle(p.mo.angle)
							Sweat.scale = 2 * p.mo.scale
							Sweat.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
						end
					elseif p.BeeFlightTimer > 75
						if leveltime % 3
							S_StartSoundAtVolume(p.mo, sfx_buzz4, 100)
						end
						if sassvisuals.value
							local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
							local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
							P_InstaThrust(Sweat, P_RandomRange(1,16)*ANGLE_22h, 4*p.mo.scale)
							Sweat.angle = FixedAngle(p.mo.angle)
							Sweat.scale = 5/2 * p.mo.scale
							Sweat.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
						end
					end
				else
					if leveltime % 3
						S_StartSoundAtVolume(p.mo, sfx_buzz4, 250)
					end
				end
				if not p.powers[pw_super]
					p.BeeFlightTimer = $+1
				end
			end
		end
		
		if p.BeeFlightTimer > 0 and p.BeeFlightTimer < 100 and (p.cmd.buttons&BT_CUSTOM1) and p.mo.momz == 0
			p.BeeFlightTimer = 101
		end
		
		if (p.skincolor == SKINCOLOR_BEEPATTERN and p.mo.state ~= S_PLAY_JUMP and not (p.pflags&PF_JUMPED))
		or p.skincolor ~= SKINCOLOR_BEEPATTERN
		or (p.mo.eflags & MFE_UNDERWATER)
		or p.mo.state == S_PLAY_CLING
		or p.mo.state == S_PLAY_CLIMB
		or (p.pflags&PF_SHIELDABILITY)
		or not (p.mo and p.valid)
			p.BeeFlightTimer = 0
		end
		
		if P_IsObjectOnGround(p.mo)
			p.sassspun = 0
		end
		
		if (p.pflags&PF_SHIELDABILITY) and p.BeeFlightTimer < 100
			p.BeeFlightTimer = 111
		end

//Secondary ability - Slightly higher jump height, slightly hover to the ground at any moment
		if p.skincolor == SKINCOLOR_BEEPATTERN and sassabilities2.value and p.mo
			p.jumpfactor = skins[p.mo.skin].jumpfactor*23/15
			if ((p.mo.momz < 0 and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz > 0 and (p.mo.eflags & MFE_VERTICALFLIP)))
			and (p.pflags&PF_JUMPED)
			or (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_WALK 
			or p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_SKID)
				if not (p.mo.eflags & MFE_UNDERWATER) and (p.cmd.buttons&BT_JUMP) and not P_IsObjectOnGround(p.mo)
				and not (p.pflags&PF_FINISHED) and not p.mo.state ~= S_PLAY_GLIDE
					p.mo.momz = $*107/120
					if leveltime % 3
						S_StartSoundAtVolume(p.mo, sfx_buzz4, 255)
					end
					if sassvisuals.value
						local Sweat = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height / 2), MT_SWEAT)
						P_InstaThrust(Sweat, P_RandomRange(1,16)*ANGLE_22h, 4*p.mo.scale)
						Sweat.angle = FixedAngle(p.mo.angle)
						Sweat.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
					end
				end
			end
		elseif p.skincolor ~= SKINCOLOR_BEEPATTERN or not sassabilities2.value
			p.jumpfactor = skins[p.mo.skin].jumpfactor
		end
	end
end)

//SKINCOLOR - DEEP SEA
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
		//Primary Ability: Water Springs
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end

		if p.skincolor == SKINCOLOR_DEEPSEA and sassabilities1.value
		and ((p.pflags&PF_JUMPED) and (p.mo.state == S_PLAY_JUMP or p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL))  //Set all alterable values for this specific skincolor
		and (p.cmd.buttons&BT_CUSTOM1) and not (p.pflags&PF_FINISHED) and p.sassspun == 0 and not (p.pflags&PF_STARTJUMP)
		and not p.WaterSpringsTimeout then
			if p.WaterSpringUses < 2
				p.WaterSpringsReady = 1
				P_SetObjectMomZ(p.mo, 0, false)
				p.mo.momx = 0
				p.mo.momy = 0
			end
		end
		
		
		if p.WaterSpringsTimer == nil
			p.WaterSpringsTimer = 0
		end
		if p.WaterSpringsTimeout == nil
			p.WaterSpringsTimeout = 0
		end
		if p.WaterSpringUses == nil
			p.WaterSpringUses = 0
		end
		
		if p.WaterSpringsReady
			S_StartSound(p.mo, sfx_bubbl1)
			if sassvisuals.value
				p.WaterSpringsTimer = $+1
				local DSBubble = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1*p.mo.height)/2, MT_WSBUBBLE)
				DSBubble.scale = 2 * p.mo.scale
				DSBubble.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
				P_InstaThrust(DSBubble, P_RandomRange(1,16)*ANGLE_22h, p.WaterSpringsTimer*FRACUNIT)
				local DSBubble2 = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1*p.mo.height)/2, MT_WSBUBBLE)
				DSBubble2.scale = 3 * p.mo.scale
				DSBubble2.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
				P_InstaThrust(DSBubble2, P_RandomRange(1,16)*ANGLE_22h, p.WaterSpringsTimer*FRACUNIT)
				local DSBubble3 = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1*p.mo.height)/2, MT_WSBUBBLE)
				DSBubble3.scale = 4 * p.mo.scale
				DSBubble3.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
				P_InstaThrust(DSBubble3, P_RandomRange(1,16)*ANGLE_22h, p.WaterSpringsTimer*FRACUNIT)
			end
		end
		
		if p.WaterSpringsTimer > 5 
		and (p.cmd.buttons&BT_CUSTOM1) and p.WaterSpringsTimeout == 0 and p.WaterSpringsReady
			S_StartSound(p.mo, sfx_splish)
			S_StartSound(p.mo, sfx_gloop)
			S_StartSound(p.mo, sfx_amwtr5)
			if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
				if not p.powers[pw_super] and not(p.mo.eflags & MFE_UNDERWATER)
					P_Thrust(p.mo, p.mo.angle, 45*FRACUNIT)
					P_SetObjectMomZ(p.mo, 12*FRACUNIT, false)
				elseif not p.powers[pw_super] and (p.mo.eflags & MFE_UNDERWATER)
					P_Thrust(p.mo, p.mo.angle, 22*FRACUNIT)
					P_SetObjectMomZ(p.mo, 9*FRACUNIT, false)
				elseif p.powers[pw_super] and not(p.mo.eflags & MFE_UNDERWATER)
					P_Thrust(p.mo, p.mo.angle, 60*FRACUNIT)
					P_SetObjectMomZ(p.mo, 18*FRACUNIT, false)	
				elseif p.powers[pw_super] and (p.mo.eflags & MFE_UNDERWATER)
					P_Thrust(p.mo, p.mo.angle, 30*FRACUNIT)
					P_SetObjectMomZ(p.mo, 12*FRACUNIT, false)
				end
			elseif p.cmd.forwardmove == 0 and p.cmd.sidemove == 0
				if not p.powers[pw_super] and not(p.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(p.mo, 28*FRACUNIT, false)
				elseif not p.powers[pw_super] and (p.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(p.mo, 22*FRACUNIT, false)
				elseif p.powers[pw_super] and not(p.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(p.mo, 50*FRACUNIT, false)
				elseif p.powers[pw_super] and (p.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(p.mo, 40*FRACUNIT, false)
				end
			end
			p.WaterSpringsReady = 0
			p.WaterSpringsTimeout = 39
			p.WaterSpringsTimer = 0
			p.WaterSpringUses = $+1
			if sassvisuals.value
				local WSSplash = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPLISH)
				WSSplash.scale = 4*p.mo.scale
			end
		end
		
		if p.WaterSpringsTimeout > 0
			p.WaterSpringsTimeout = $-1
		end
		
		if p.WaterSpringsReady and not (p.cmd.buttons&BT_CUSTOM1)
			p.WaterSpringsReady = 0
		end
		
		if (p.pflags&PF_SHIELDABILITY) and p.WaterSpringsReady
			p.WaterSpringUses = 3
			p.WaterSpringsTimer = 0
			p.WaterSpringsTimeout = 39
		end
		
		if p.skincolor ~= SKINCOLOR_DEEPSEA or (p.mo.state ~= S_PLAY_JUMP and not (p.pflags&PF_JUMPED) and p.powers[pw_carry] ~= CR_NONE)
		or p.mo.state == S_PLAY_SPRING or not (p.pflags&PF_JUMPED) or p.mo.state == S_PLAY_RIDE
		or p.powers[pw_carry] ~= CR_NONE// Cancel any values
			p.WaterSpringsReady = 0
			p.WaterSpringsTimeout = 0
			p.WaterSpringUses = 0
			p.WaterSpringsTimer = 0
		end
		
		if P_IsObjectOnGround(p.mo)
			p.sassspun = 0
			p.WaterSpringUses = 0
			p.WaterSpringsTimer = 0
		end
		
		
		//Secondary ability: Immunity to water and goop slowing you down, except for springs.
		if (p.skincolor == SKINCOLOR_DEEPSEA and (p.mo.eflags & MFE_UNDERWATER)) and sassabilities2.value
			p.acceleration = skins[p.mo.skin].acceleration*17/10
			if not (p.mo.state == S_PLAY_SWIM or p.mo.state == S_PLAY_GLIDE)
				p.actionspd = skins[p.mo.skin].actionspd* 2
			end
			if p.normalspeed == skins[p.mo.skin].normalspeed
				p.normalspeed = skins[p.mo.skin].normalspeed*2
			end
			p.jumpfactor = skins[p.mo.skin].jumpfactor* 15/12
			if not P_IsObjectOnGround(p.mo) and not P_IsObjectInGoop(p.mo)
			and (p.mo.state == S_PLAY_JUMP or p.mo.state == S_PLAY_WALK or
			p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_DASH or
			p.mo.state == S_PLAY_RUN or ((p.pflags&PF_JUMPED) and(p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL))
			or p.mo.state == S_PLAY_PAIN)
				p.mo.momz = $ + P_GetMobjGravity(p.mo) * 14/12
			end
		elseif p.skincolor ~= SKINCOLOR_DEEPSEA or (p.skincolor == SKINCOLOR_DEEPSEA and not (p.mo.eflags & MFE_UNDERWATER)) or not sassabilities2.value
			if p.normalspeed == skins[p.mo.skin].normalspeed*2
				p.normalspeed = skins[p.mo.skin].normalspeed
			end
		end
	end
end)

//SKINCOLOR - TOXIC RADIATION
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
//Main ability - Toxic Wave
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end
		
		if p.ToxicSineTimer == nil
			p.ToxicSineTimer = 0
		end
		
		if p.skincolor == SKINCOLOR_TOXICRADIATION and sassabilities1.value and (p.pflags&PF_JUMPED) and not (p.pflags&PF_STARTJUMP)
		and (p.mo.state == S_PLAY_JUMP or p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL) and not p.ToxicSineUsed //Set all alterable values for this specific skincolor
		and (p.cmd.buttons&BT_CUSTOM1) and not (p.pflags&PF_FINISHED) and p.sassspun == 0 and p.mo.state != S_PLAY_GLIDE
		and p.ToxicSineTimer < 350 then
			if leveltime % 8
				S_StartSoundAtVolume(p.mo, sfx_steam2, p.ToxicSineTimer*2/7)
			end
			p.ToxicSineTimer = $+1
			p.ToxicSineActivated = 1
			if not p.powers[pw_super] and ((p.mo.momz < (-2-p.ToxicSineTimer/10)*FRACUNIT and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz > (2+p.ToxicSineTimer/12)*FRACUNIT  and (p.mo.eflags & MFE_VERTICALFLIP)))
				p.ToxicSineDirection = 1
			elseif p.powers[pw_super] and ((p.mo.momz < (-2-p.ToxicSineTimer/5)*FRACUNIT and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz > (2+p.ToxicSineTimer/6)*FRACUNIT  and (p.mo.eflags & MFE_VERTICALFLIP)))
				p.ToxicSineDirection = 1	
			elseif not p.powers[pw_super] and ((p.mo.momz > (3+p.ToxicSineTimer/10)*FRACUNIT and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz < (-3-p.ToxicSineTimer/12)*FRACUNIT  and (p.mo.eflags & MFE_VERTICALFLIP)))
				p.ToxicSineDirection = -1
			elseif p.powers[pw_super] and ((p.mo.momz > (3+p.ToxicSineTimer/5)*FRACUNIT and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz < (-3-p.ToxicSineTimer/6)*FRACUNIT  and (p.mo.eflags & MFE_VERTICALFLIP)))
				p.ToxicSineDirection = -1	
			end
			if sassvisuals.value and p.ToxicSineTimer > 0 and p.ToxicSineActivated == 1
				local Cloud = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (1*p.mo.height)/2, MT_TRCLOUD)
				Cloud.scale = 11/10 * p.mo.scale
				Cloud.eflags = $1 | (p.mo.eflags & MFE_VERTICALFLIP)
			end
		end
		
		if p.ToxicSineDirection == 1 and p.ToxicSineActivated == 1 and not p.ToxicSineUsed
		and p.ToxicSineTimer < 350
			if not p.powers[pw_super]
				P_SetObjectMomZ(p.mo, 5*FRACUNIT, true)
			elseif p.powers[pw_super]
				P_SetObjectMomZ(p.mo, 10*FRACUNIT, true)
			end
		elseif p.ToxicSineDirection == -1 and p.ToxicSineActivated == 1 and not p.ToxicSineUsed
		and p.ToxicSineTimer < 350
			if not p.powers[pw_super]
				P_SetObjectMomZ(p.mo, -1*31/15*FRACUNIT, true)
			elseif p.powers[pw_super]
				P_SetObjectMomZ(p.mo, -1*62/15*FRACUNIT, true)
			end
		end
		
		if p.ToxicSineActivated == 1 and not (p.cmd.buttons&BT_CUSTOM1)
			p.ToxicSineActivated = 0
			p.ToxicSineTimer = 0
			p.ToxicSineUsed = 1
			p.ToxicSineDirection = 0
		end
		if (p.pflags&PF_SHIELDABILITY) and p.ToxicSineActivated
			p.ToxicSineUsed = 1
			p.ToxicSineTimer = 0
			p.ToxicSineDirection = 0
			p.ToxicSineActivated = 0
		end
		if p.ToxicSineActivated and (p.pflags&PF_THOKKED)
			p.ToxicSineUsed = 1
			p.ToxicSineTimer = 0
			p.ToxicSineDirection = 0
			p.ToxicSineActivated = 0
		end
		
		if p.ToxicSineActivated == 1 and (p.cmd.buttons&BT_CUSTOM1) and p.mo.momz == 0
			P_SetObjectMomZ(p.mo, 1*FRACUNIT)
		end
		
		if p.skincolor ~= SKINCOLOR_TOXICRADIATION or (p.mo.state ~= S_PLAY_JUMP and not (p.pflags&PF_JUMPED) and p.powers[pw_carry] ~= CR_NONE)
		or p.mo.state == S_PLAY_SPRING or not (p.pflags&PF_JUMPED) or p.mo.state == S_PLAY_RIDE
		or p.powers[pw_carry] ~= CR_NONE// Cancel any values
			p.ToxicSineActivated = 0
			p.ToxicSineTimer = 0
			p.ToxicSineUsed = 0
			p.ToxicSineDirection = 0
		end
		
		if P_IsObjectOnGround(p.mo)
			p.sassspun = 0
			p.ToxicSineActivated = 0
			p.ToxicSineTimer = 0
			p.ToxicSineUsed = 0
			p.ToxicSineDirection = 0
		end
		
		if p.skincolor ~= SKINCOLOR_TOXICRADIATION and P_IsObjectOnGround(p.mo)
			p.pflags = $&~PF_JUMPED
		end
	end
end)

//Secondary Ability: Damage enemies and monitors on touch, without any bonuses and be immune to toxic material
addHook("ShouldDamage", function(target, inflictor, source, damage)
    if target.player.skincolor == SKINCOLOR_TOXICRADIATION and sassabilities2.value and target.player.mo
        if (inflictor and inflictor.flags & MF_ENEMY)
			target.player.pflags = $|PF_JUMPED
            return false
		elseif (source and source.flags & MF_ENEMY)
			target.player.pflags = $|PF_JUMPED
			return false
		end
		if not inflictor and not source and P_PlayerTouchingSectorSpecial(target.player, 1, 2)
            return false
        end
    end
end, MT_PLAYER)

addHook("MobjCollide", function(Monitor, p)
	if p
	and p.player
	and (Monitor.flags&MF_MONITOR)
	and sassabilities2.value
	and not (p.player.pflags&PF_JUMPED)
	and p.player.skincolor == SKINCOLOR_TOXICRADIATION
	and p.z <= Monitor.z + Monitor.height and p.z + p.height >= Monitor.z
		p.player.pflags = $|PF_JUMPED
	end
end)

//SKINCOLOR - PEPPERMINT CANDY
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
//Main ability - Sweet Dive Bounce
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end
		
		if P_IsObjectOnGround(p.mo) and p.SweetDiveBounce == 1
			p.sassspun = 0
			p.SweetDiveBounce = 0
			p.SweetDiveActive = 0
		end
		
		if P_IsObjectOnGround(p.mo) and p.SweetDiveActive == 1 and not p.SweetDiveBounce
			S_StartSound(p.mo, sfx_s3k49)
			p.SweetDiveBounce = 1
			if not (p.mo.eflags & MFE_UNDERWATER) and not p.powers[pw_super]  //thrust player exponentially as camera controls it
				P_Thrust(p.mo, p.mo.angle, 20*FRACUNIT)
				P_SetObjectMomZ(p.mo, 10*FRACUNIT, false)
			elseif (p.mo.eflags & MFE_UNDERWATER) and not p.powers[pw_super]
				P_Thrust(p.mo, p.mo.angle, 10*FRACUNIT)
				P_SetObjectMomZ(p.mo, 5*FRACUNIT, false)
			elseif not (p.mo.eflags & MFE_UNDERWATER) and p.powers[pw_super]
				P_Thrust(p.mo, p.mo.angle, 40*FRACUNIT)
				P_SetObjectMomZ(p.mo, 20*FRACUNIT, false)
			elseif (p.mo.eflags & MFE_UNDERWATER) and p.powers[pw_super]
				P_Thrust(p.mo, p.mo.angle, 20*FRACUNIT)
				P_SetObjectMomZ(p.mo, 10*FRACUNIT, false)
			end
			p.SweetDiveActive = 0
			p.mo.state = S_PLAY_JUMP
			p.pflags = $|PF_JUMPED
		end
		
		if p.skincolor == SKINCOLOR_PEPPERMINTCANDY and sassabilities1.value and (p.pflags&PF_JUMPED) and not (p.pflags&PF_STARTJUMP)
		and (p.mo.state == S_PLAY_JUMP or p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL) and not p.SweetDiveActive//Set all alterable values for this specific skincolor
		and (p.cmd.buttons&BT_CUSTOM1) and not (p.pflags&PF_FINISHED) and p.sassspun == 0 and p.mo.state != S_PLAY_GLIDE and not p.SweetDiveBounce then
			p.SweetDiveActive = 1
			p.SweetDiveBounce = 0
			if not (p.mo.eflags & MFE_UNDERWATER) and not p.powers[pw_super]  //thrust player exponentially as camera controls it
				P_Thrust(p.mo, p.mo.angle, 15*FRACUNIT)
				P_SetObjectMomZ(p.mo, 20*FRACUNIT, true)
			elseif (p.mo.eflags & MFE_UNDERWATER) and not p.powers[pw_super]
				P_Thrust(p.mo, p.mo.angle, 7*FRACUNIT)
				P_SetObjectMomZ(p.mo, 10*FRACUNIT, true)
			elseif not (p.mo.eflags & MFE_UNDERWATER) and p.powers[pw_super]
				P_Thrust(p.mo, p.mo.angle, 30*FRACUNIT)
				P_SetObjectMomZ(p.mo, 40*FRACUNIT, true)
			elseif (p.mo.eflags & MFE_UNDERWATER) and p.powers[pw_super]
				P_Thrust(p.mo, p.mo.angle, 15*FRACUNIT)
				P_SetObjectMomZ(p.mo, 20*FRACUNIT, true)
			end
		end
		
		if p.skincolor ~= SKINCOLOR_PEPPERMINTCANDY or (p.mo.state ~= S_PLAY_JUMP and not (p.pflags&PF_JUMPED) and p.powers[pw_carry] ~= CR_NONE)
		or p.mo.state == S_PLAY_SPRING or not (p.pflags&PF_JUMPED) or p.mo.state == S_PLAY_RIDE
		or p.powers[pw_carry] ~= CR_NONE
		or (p.mo.state == S_PLAY_PAIN or p.mo.state == S_PLAY_DEAD or p.mo.state == S_PLAY_DRWN)// Cancel any values
			p.SweetDiveActive = 0
			p.SweetDiveBounce = 0
		end
		
		if p.SweetDiveActive == 1
			if (p.mo.momz <= 0 and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz >= 0 and (p.mo.eflags & MFE_VERTICALFLIP)) 
				p.mo.momz = $ * 9/8
			elseif (p.mo.momz > 0 and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz < 0 and (p.mo.eflags & MFE_VERTICALFLIP))
				p.mo.momz = $ + P_GetMobjGravity(p.mo) * 18/12
			end
		end
		
		if p.skincolor ~= SKINCOLOR_GOATHORN and P_IsObjectOnGround(p.mo)
			p.pflags = $&~PF_JUMPED
		end
//Secondary Ability- Refresh character Abilities
		if sassabilities2.value and (p.pflags&PF_THOKKED) and not (p.charflags&SF_MULTIABILITY)
		and (p.mo.state == S_PLAY_FLY_TIRED or p.mo.state == S_PLAY_FALL or p.mo.state == S_PLAY_JUMP)
		and p.skincolor == SKINCOLOR_PEPPERMINTCANDY
			p.mo.state = S_PLAY_ROLL
			p.pflags = $&~PF_THOKKED
			p.pflags = $|PF_JUMPED
		end
	end
end)

//SKINCOLOR - GOAT HORN
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.valid) or SASSMenu
			return
		end
//Main ability - Hown Blow
		if p.powers[pw_carry] ~= CR_NONE
			p.sassspun = 1
		end
		
		if P_IsObjectOnGround(p.mo)
			p.sassspun = 0
			p.HornBlowActive = 0
			p.HornBlowUses = 0
			S_StopSoundByID(p.mo, sfx_sshb)
		end
		
		if p.HornBlowUses == nil
			p.HornBlowUses = 0
		end
		
		if p.skincolor == SKINCOLOR_GOATHORN and sassabilities1.value and (p.pflags&PF_JUMPED) and not (p.pflags&PF_STARTJUMP)
		and (p.mo.state == S_PLAY_JUMP or p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL) and p.HornBlowUses < 3//Set all alterable values for this specific skincolor
		and (p.cmd.buttons&BT_CUSTOM1) and not (p.pflags&PF_FINISHED) and p.sassspun == 0 and p.mo.state != S_PLAY_GLIDE then
			if not p.HornBlowActive
				p.HornBlowActive = 1
				S_StartSound(p.mo, sfx_sshb)
			end
		end
		
		if p.HornBlowTimer == nil
			p.HornBlowTimer = 0
		end
		
		if p.HornBlowActive == 1
			if not p.powers[pw_super]
				if not(p.mo.eflags&MFE_UNDERWATER)
					P_SetObjectMomZ(p.mo, FRACUNIT*6/9, true)
					P_Thrust(p.mo, p.mo.angle, 1*FRACUNIT)
				else
					P_SetObjectMomZ(p.mo, FRACUNIT*3/9, true)
					P_Thrust(p.mo, p.mo.angle, FRACUNIT*1/2)
				end
			else
				if not(p.mo.eflags&MFE_UNDERWATER)
					P_SetObjectMomZ(p.mo, FRACUNIT*12/9, true)
					P_Thrust(p.mo, p.mo.angle, 2*FRACUNIT)
				else
					P_SetObjectMomZ(p.mo, FRACUNIT*6/9, true)
					P_Thrust(p.mo, p.mo.angle, FRACUNIT)
				end
			end
			p.HornBlowTimer = $+1
		end
		
		if p.HornBlowActive and not S_SoundPlaying(p.mo, sfx_sshb)
			p.HornBlowUses = $+1
			p.HornBlowActive = 0
			p.HornBlowTimer = 0
		end
		
		if p.skincolor ~= SKINCOLOR_GOATHORN or (p.mo.state ~= S_PLAY_JUMP and not (p.pflags&PF_JUMPED) and p.powers[pw_carry] ~= CR_NONE)
		or p.mo.state == S_PLAY_SPRING or not (p.pflags&PF_JUMPED) or p.mo.state == S_PLAY_RIDE
		or p.powers[pw_carry] ~= CR_NONE// Cancel any values
			p.HornBlowActive = 0
			p.HornBlowUses = 0
			p.HornBlowTimer = 0
			S_StopSoundByID(p.mo, sfx_sshb)
		end
		
		if p.HornBlowActive and p.mo.momz == 0
			p.HornBlowUses = 5
			p.HornBlowActive = 0
			p.HornBlowTimer = 0
		end
		
//Secondary ability - Dash like a goat
		if p.skincolor == SKINCOLOR_GOATHORN and sassabilities2.value and p.mo
		and (p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_DASH)
			if p.normalspeed == skins[p.mo.skin].normalspeed
				p.normalspeed = skins[p.mo.skin].normalspeed*3/2
			end
			if not p.skincolor == SKINCOLOR_DEEPSEA
				p.acceleration = skins[p.mo.skin].acceleration*6/4
			end
		elseif p.skincolor ~= SKINCOLOR_GOATHORN or not sassabilities2.value
		or (p.skincolor == SKINCOLOR_GOATHORN and not (p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_DASH))
			if p.normalspeed == skins[p.mo.skin].normalspeed*3/2
				p.normalspeed = skins[p.mo.skin].normalspeed
			end
			if not p.skincolor == SKINCOLOR_DEEPSEA
				p.acceleration = skins[p.mo.skin].acceleration
			end
		end
	end
end)
addHook("ShouldDamage", function(target, inflictor, source, damage)
    if target.player.skincolor == SKINCOLOR_GOATHORN and sassabilities2.value and target.player.mo
	and (target.player.mo.state == S_PLAY_RUN or target.player.mo.state == S_PLAY_DASH)
        if (inflictor and inflictor.flags & MF_ENEMY)
			target.player.pflags = $|PF_JUMPED
            return false
		elseif (source and source.flags & MF_ENEMY)
			target.player.pflags = $|PF_JUMPED
			return false
		end
    end
end, MT_PLAYER)
addHook("PlayerThink", function(player)
    if player and player.mo and player.valid and player.mo.valid
		if player.speed >= skins[player.mo.skin].runspeed
		and player.skincolor == SKINCOLOR_GOATHORN
    		for x=player.mo.x-(player.mo.radius*2),player.mo.x+(player.mo.radius*2),player.mo.radius
    			for y=player.mo.y-(player.mo.radius*2),player.mo.y+(player.mo.radius*2),player.mo.radius
                    local ss = R_PointInSubsector(x,y)
                    for fof in ss.sector.ffloors()
                        if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
                            if ((player.mo.z+player.mo.momz<=fof.topheight and player.mo.z+player.mo.height+player.mo.momz >= fof.bottomheight)
                            or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz>=fof.bottomheight and player.mo.z-player.mo.height-player.mo.momz<=fof.topheight)))
                                EV_CrumbleChain(ss.sector, fof)
                            end
                        end
                    end
                end
            end
        end
    end
end)